# Root Element

Element | Description | Class
--- | --- | ---
broker | An ActiveMQ Message Broker. It consists of a number of transport connectors, network connectors and a bunch of properties which can be used to configure the broker as its lazily created. | org.apache.activemq.xbean.XBeanBrokerService

# Element Summary

Element | Description | Class
--- | --- | ---
abortSlowConsumerStrategy | Abort slow consumers when they reach the configured threshold of slowness, default is slow for 30 seconds | org.apache.activemq.broker.region.policy.AbortSlowConsumerStrategy
amqPersistenceAdapter | An implementation of {@link PersistenceAdapter} designed for use with a {@link Journal} and then check pointing asynchronously on a timeout with some other long term persistent storage. | org.apache.activemq.store.amq.AMQPersistenceAdapter
amqPersistenceAdapterFactory | An implementation of {@link PersistenceAdapterFactory} | org.apache.activemq.store.amq.AMQPersistenceAdapterFactory
authenticationUser | A helper object used to configure simple authentiaction plugin | org.apache.activemq.security.AuthenticationUser
authorizationEntry | Represents an entry in a {@link DefaultAuthorizationMap} for assigning different operations (read, write, admin) of user roles to a specific destination or a hierarchical wildcard area of destinations. | org.apache.activemq.security.AuthorizationEntry
authorizationMap | Represents a destination based configuration of policies so that individual destinations or wildcard hierarchies of destinations can be configured using different policies. Each entry in the map represents the authorization ACLs for each operation. | org.apache.activemq.security.DefaultAuthorizationMap
authorizationPlugin | An authorization plugin where each operation on a destination is checked against an authorizationMap | org.apache.activemq.security.AuthorizationPlugin
axionJDBCAdapter | Axion specific Adapter. Axion does not seem to support ALTER statements or sub-selects. This means: - We cannot auto upgrade the schema was we roll out new versions of ActiveMQ - We cannot delete durable sub messages that have be acknowledged by all consumers. | org.apache.activemq.store.jdbc.adapter.AxionJDBCAdapter

blobJDBCAdapter

This JDBCAdapter inserts and extracts BLOB data using the getBlob()/setBlob() operations. This is a little more involved since to insert a blob you have to: 1: insert empty blob. 2: select the blob 3: finally update the blob with data value. The databases/JDBC drivers that use this adapter are:

org.apache.activemq.store.jdbc.adapter.BlobJDBCAdapter

broker | An ActiveMQ Message Broker. It consists of a number of transport connectors, network connectors and a bunch of properties which can be used to configure the broker as its lazily created. | org.apache.activemq.xbean.XBeanBrokerService
brokerService | Manages the lifecycle of an ActiveMQ Broker. A BrokerService consists of a number of transport connectors, network connectors and a bunch of properties which can be used to configure the broker as its lazily created. | org.apache.activemq.broker.BrokerService
bytesJDBCAdapter | This JDBCAdapter inserts and extracts BLOB data using the setBytes()/getBytes() operations. The databases/JDBC drivers that use this adapter are: | org.apache.activemq.store.jdbc.adapter.BytesJDBCAdapter
cachedLDAPAuthorizationMap | A {@link DefaultAuthorizationMap} implementation which uses LDAP to initialize and update authorization policy. | org.apache.activemq.security.CachedLDAPAuthorizationMap
commandAgent | An agent which listens to commands on a JMS destination | org.apache.activemq.broker.util.CommandAgent
compositeDemandForwardingBridge | A demand forwarding bridge which works with multicast style transports where a single Transport could be communicating with multiple remote brokers | org.apache.activemq.network.CompositeDemandForwardingBridge
compositeQueue | Represents a virtual queue which forwards to a number of other destinations. | org.apache.activemq.broker.region.virtual.CompositeQueue
compositeTopic | Represents a virtual topic which forwards to a number of other destinations. | org.apache.activemq.broker.region.virtual.CompositeTopic
conditionalNetworkBridgeFilterFactory | implement conditional behaviour for queue consumers, allows replaying back to origin if no consumers are present on the local broker after a configurable delay, irrespective of the networkTTL Also allows rate limiting of messages through the network, useful for static includes | org.apache.activemq.network.ConditionalNetworkBridgeFilterFactory
connectionDotFilePlugin | A DOT file creator plugin which creates a DOT file showing the current connections | org.apache.activemq.broker.view.ConnectionDotFilePlugin
connectionFactory | A Spring enhanced connection factory which will automatically use the Spring bean name as the clientIDPrefix property so that connections created have client IDs related to your Spring.xml file for easier comprehension from JMX. | org.apache.activemq.spring.ActiveMQConnectionFactory
constantPendingMessageLimitStrategy | This PendingMessageLimitStrategy is configured to a constant value for all subscriptions. | org.apache.activemq.broker.region.policy.ConstantPendingMessageLimitStrategy
database-locker | Represents an exclusive lock on a database to avoid multiple brokers running against the same logical database. | org.apache.activemq.store.jdbc.DefaultDatabaseLocker
db2JDBCAdapter |  | org.apache.activemq.store.jdbc.adapter.DB2JDBCAdapter
defaultIOExceptionHandler |  | org.apache.activemq.util.DefaultIOExceptionHandler

defaultJDBCAdapter

Implements all the default JDBC operations that are used by the JDBCPersistenceAdapter.

sub-classing is encouraged to override the default implementation of methods to account for differences in JDBC Driver implementations.

The JDBCAdapter inserts and extracts BLOB data using the getBytes()/setBytes() operations.

The databases/JDBC drivers that use this adapter are:

org.apache.activemq.store.jdbc.adapter.DefaultJDBCAdapter

defaultNetworkBridgeFilterFactory | implement default behaviour, filter that will not allow resend to origin based on brokerPath and which respects networkTTL | org.apache.activemq.network.DefaultNetworkBridgeFilterFactory
defaultUsageCapacity | Identify if a limit has been reached | org.apache.activemq.usage.DefaultUsageCapacity
demandForwardingBridge | Forwards messages from the local broker to the remote broker based on demand. | org.apache.activemq.network.DemandForwardingBridge
destinationDotFilePlugin | A DOT file creator plugin which creates a DOT file showing the current topic & queue hierarchies. | org.apache.activemq.broker.view.DestinationDotFilePlugin
destinationEntry | A default entry in a DestinationMap which holds a single value. | org.apache.activemq.filter.DefaultDestinationMapEntry
destinationPathSeparatorPlugin |  | org.apache.activemq.broker.util.DestinationPathSeparatorBroker
discardingDLQBrokerPlugin |  | org.apache.activemq.plugin.DiscardingDLQBrokerPlugin
fileCursor | Pending messages | org.apache.activemq.broker.region.policy.FilePendingSubscriberMessageStoragePolicy
fileDurableSubscriberCursor | Pending messages for durable subscribers | org.apache.activemq.broker.region.policy.FilePendingDurableSubscriberMessageStoragePolicy
fileQueueCursor | Pending | org.apache.activemq.broker.region.policy.FilePendingQueueMessageStoragePolicy
filteredDestination | Represents a destination which is filtered using some predicate such as a selector so that messages are only dispatched to the destination if they match the filter. | org.apache.activemq.broker.region.virtual.FilteredDestination
filteredKahaDB |  | org.apache.activemq.store.kahadb.FilteredKahaDBPersistenceAdapter
fixedCountSubscriptionRecoveryPolicy | This implementation of {@link SubscriptionRecoveryPolicy} will keep a fixed count of last messages. | org.apache.activemq.broker.region.policy.FixedCountSubscriptionRecoveryPolicy
fixedSizedSubscriptionRecoveryPolicy | This implementation of {@link SubscriptionRecoveryPolicy} will keep a fixed amount of memory available in RAM for message history which is evicted in time order. | org.apache.activemq.broker.region.policy.FixedSizedSubscriptionRecoveryPolicy
forcePersistencyModeBroker | A Plugin which allows to force every incoming message to be PERSISTENT or NON-PERSISTENT. Useful, if you have set the broker usage policy to process ONLY persistent or ONLY non-persistent messages. | org.apache.activemq.plugin.ForcePersistencyModeBroker
forcePersistencyModeBrokerPlugin | A Plugin which allows to force every incoming message to be PERSISTENT or NON-PERSISTENT. Useful, if you have set the broker usage policy to process ONLY persistent or ONLY non-persistent messages. | org.apache.activemq.plugin.ForcePersistencyModeBrokerPlugin
forwardingBridge | Forwards all messages from the local broker to the remote broker. | org.apache.activemq.network.ForwardingBridge
hsqldb-jdbc-adapter |  | org.apache.activemq.store.jdbc.adapter.HsqldbJDBCAdapter

imageBasedJDBCAdaptor

Provides JDBCAdapter since that uses IMAGE datatype to hold binary data. The databases/JDBC drivers that use this adapter are:

- Sybase
- MS SQL

org.apache.activemq.store.jdbc.adapter.ImageBasedJDBCAdaptor

inboundQueueBridge | Create an Inbound Queue Bridge. By default this class uses the sname name for both the inbound and outbound queue. This behavior can be overridden however by using the setter methods to configure both the inbound and outboud queue names separately. | org.apache.activemq.network.jms.InboundQueueBridge
inboundTopicBridge | Create an Inbound Topic Bridge. By default this class uses the topic name for both the inbound and outbound topic. This behavior can be overridden however by using the setter methods to configure both the inbound and outboud topic names separately. | org.apache.activemq.network.jms.InboundTopicBridge
individualDeadLetterStrategy | A {@link DeadLetterStrategy} where each destination has its own individual DLQ using the subject naming hierarchy. | org.apache.activemq.broker.region.policy.IndividualDeadLetterStrategy
informixJDBCAdapter | JDBC Adapter for Informix database. Because Informix database restricts length of composite primary keys, length of container name field and subscription id field must be reduced to 150 characters. Therefore be sure not to use longer names for container name and subscription id than 150 characters. | org.apache.activemq.store.jdbc.adapter.InformixJDBCAdapter
jDBCIOExceptionHandler |  | org.apache.activemq.store.jdbc.JDBCIOExceptionHandler
jaasAuthenticationPlugin | Provides a JAAS based authentication plugin | org.apache.activemq.security.JaasAuthenticationPlugin
jaasCertificateAuthenticationPlugin | Provides a JAAS based SSL certificate authentication plugin | org.apache.activemq.security.JaasCertificateAuthenticationPlugin
jaasDualAuthenticationPlugin | Provides a JAAS based authentication plugin | org.apache.activemq.security.JaasDualAuthenticationPlugin
jdbcPersistenceAdapter | A {@link PersistenceAdapter} implementation using JDBC for persistence storage. This persistence adapter will correctly remember prepared XA transactions, but it will not keep track of local transaction commits so that operations performed against the Message store are done as a single uow. | org.apache.activemq.store.jdbc.JDBCPersistenceAdapter
jmsQueueConnector | A Bridge to other JMS Queue providers | org.apache.activemq.network.jms.JmsQueueConnector
jmsTopicConnector | A Bridge to other JMS Topic providers | org.apache.activemq.network.jms.JmsTopicConnector
journalPersistenceAdapter | An implementation of {@link PersistenceAdapter} designed for use with a {@link Journal} and then check pointing asynchronously on a timeout with some other long term persistent storage. | org.apache.activemq.store.journal.JournalPersistenceAdapter
journalPersistenceAdapterFactory | Factory class that can create PersistenceAdapter objects. | org.apache.activemq.store.journal.JournalPersistenceAdapterFactory
journaledJDBC | Creates a default persistence model using the Journal and JDBC | org.apache.activemq.store.PersistenceAdapterFactoryBean
kahaDB | An implementation of {@link PersistenceAdapter} designed for use with KahaDB - Embedded Lightweight Non-Relational Database | org.apache.activemq.store.kahadb.KahaDBPersistenceAdapter
kahaPersistenceAdapter |  | org.apache.activemq.store.kahadaptor.KahaPersistenceAdapter
lDAPAuthorizationMap | An {@link AuthorizationMap} which uses LDAP | org.apache.activemq.security.LDAPAuthorizationMap
lastImageSubscriptionRecoveryPolicy | This implementation of {@link SubscriptionRecoveryPolicy} will only keep the last message. | org.apache.activemq.broker.region.policy.LastImageSubscriptionRecoveryPolicy
ldapNetworkConnector | class to create dynamic network connectors listed in an directory server using the LDAP v3 protocol as defined in RFC 2251, the entries listed in the directory server must implement the ipHost and ipService objectClasses as defined in RFC 2307. | org.apache.activemq.network.LdapNetworkConnector
lease-database-locker | Represents an exclusive lease on a database to avoid multiple brokers running against the same logical database. | org.apache.activemq.store.jdbc.LeaseDatabaseLocker
levelDB | An implementation of {@link org.apache.activemq.store.PersistenceAdapter} designed for use with LevelDB - Embedded Lightweight Non-Relational Database | org.apache.activemq.store.leveldb.LevelDBPersistenceAdapter
loggingBrokerPlugin | A simple Broker intercepter which allows you to enable/disable logging. | org.apache.activemq.broker.util.LoggingBrokerPlugin
mKahaDB | An implementation of {@link org.apache.activemq.store.PersistenceAdapter} that supports distribution of destinations across multiple kahaDB persistence adapters | org.apache.activemq.store.kahadb.MultiKahaDBPersistenceAdapter
managementContext | An abstraction over JMX mbean registration | org.apache.activemq.broker.jmx.ManagementContext
masterConnector | Connects a Slave Broker to a Master when using Master Slave for High Availability of messages. | org.apache.activemq.broker.ft.MasterConnector
maxdb-jdbc-adapter | JDBC Adapter for the MaxDB database. | org.apache.activemq.store.jdbc.adapter.MaxDBJDBCAdapter
memoryPersistenceAdapter |  | org.apache.activemq.store.memory.MemoryPersistenceAdapter
memoryUsage | Used to keep track of how much of something is being used so that a productive working set usage can be controlled. Main use case is manage memory usage. | org.apache.activemq.usage.MemoryUsage
messageGroupHashBucketFactory | A factory to create instances of {@link SimpleMessageGroupMap} when implementing the Message Groups functionality. | org.apache.activemq.broker.region.group.MessageGroupHashBucketFactory
mirroredQueue | Creates Mirrored Queue using a prefix and postfix to define the topic name on which to mirror the queue to. | org.apache.activemq.broker.region.virtual.MirroredQueue
multicastNetworkConnector | A network connector which uses some kind of multicast-like transport that communicates with potentially many remote brokers over a single logical {@link Transport} instance such as when using multicast. This implementation does not depend on multicast at all; any other group based transport could be used. | org.apache.activemq.network.MulticastNetworkConnector
multicastTraceBrokerPlugin | A Broker interceptor which allows you to trace all operations to a Multicast socket. | org.apache.activemq.broker.util.MulticastTraceBrokerPlugin
mysql-jdbc-adapter |  | org.apache.activemq.store.jdbc.adapter.MySqlJDBCAdapter
networkConnector | A network connector which uses a discovery agent to detect the remote brokers available and setup a connection to each available remote broker | org.apache.activemq.network.DiscoveryNetworkConnector
noSubscriptionRecoveryPolicy | This SubscriptionRecoveryPolicy disable recovery of messages. | org.apache.activemq.broker.region.policy.NoSubscriptionRecoveryPolicy
oldestMessageEvictionStrategy | An eviction strategy which evicts the oldest message first (which is the default). | org.apache.activemq.broker.region.policy.OldestMessageEvictionStrategy
oldestMessageWithLowestPriorityEvictionStrategy | An eviction strategy which evicts the oldest message with the lowest priority first. | org.apache.activemq.broker.region.policy.OldestMessageWithLowestPriorityEvictionStrategy

oracleBlobJDBCAdapter

Implements all the default JDBC operations that are used by the JDBCPersistenceAdapter.

Subclassing is encouraged to override the default implementation of methods to account for differences in JDBC Driver implementations.

The JDBCAdapter inserts and extracts BLOB data using the getBytes()/setBytes() operations.

The databases/JDBC drivers that use this adapter are:

org.apache.activemq.store.jdbc.adapter.OracleBlobJDBCAdapter

oracleJDBCAdapter | Implements all the default JDBC operations that are used by the JDBCPersistenceAdapter. Subclassing is encouraged to override the default implementation of methods to account for differences in JDBC Driver implementations. | org.apache.activemq.store.jdbc.adapter.OracleJDBCAdapter
outboundQueueBridge | Create an Outbound Queue Bridge. By default the bridge uses the same name for both the inbound and outbound queues, however this can be altered by using the public setter methods to configure both inbound and outbound queue names. | org.apache.activemq.network.jms.OutboundQueueBridge
outboundTopicBridge | Create an Outbound Topic Bridge. By default the bridge uses the same name for both the inbound and outbound topics, however this can be altered by using the public setter methods to configure both inbound and outbound topic names. | org.apache.activemq.network.jms.OutboundTopicBridge
pListStore |  | org.apache.activemq.store.kahadb.plist.PListStore
policyEntry | Represents an entry in a {@link PolicyMap} for assigning policies to a specific destination or a hierarchical wildcard area of destinations. | org.apache.activemq.broker.region.policy.PolicyEntry
policyMap | Represents a destination based configuration of policies so that individual destinations or wildcard hierarchies of destinations can be configured using different policies. | org.apache.activemq.broker.region.policy.PolicyMap

postgresql-jdbc-adapter

Implements all the default JDBC operations that are used by the JDBCPersistenceAdapter.

Subclassing is encouraged to override the default implementation of methods to account for differences in JDBC Driver implementations.

The JDBCAdapter inserts and extracts BLOB data using the getBytes()/setBytes() operations.

The databases/JDBC drivers that use this adapter are:

org.apache.activemq.store.jdbc.adapter.PostgresqlJDBCAdapter

prefetchPolicy | Defines the prefetch message policies for different types of consumers | org.apache.activemq.ActiveMQPrefetchPolicy
prefetchRatePendingMessageLimitStrategy | This PendingMessageLimitStrategy sets the maximum pending message limit value to be a multiplier of the prefetch limit of the subscription. | org.apache.activemq.broker.region.policy.PrefetchRatePendingMessageLimitStrategy
priorityNetworkDispatchPolicy | dispatch policy that ignores lower priority duplicate network consumers, used in conjunction with network bridge suppresDuplicateTopicSubscriptions | org.apache.activemq.broker.region.policy.PriorityNetworkDispatchPolicy
proxyConnector |  | org.apache.activemq.proxy.ProxyConnector
queryBasedSubscriptionRecoveryPolicy | This implementation of {@link SubscriptionRecoveryPolicy} will perform a user specific query mechanism to load any messages they may have missed. | org.apache.activemq.broker.region.policy.QueryBasedSubscriptionRecoveryPolicy
queue | An ActiveMQ Queue | org.apache.activemq.command.ActiveMQQueue
queueDispatchSelector | Queue dispatch policy that determines if a message can be sent to a subscription | org.apache.activemq.broker.region.QueueDispatchSelector
reconnectionPolicy | A policy object that defines how a {@link JmsConnector} deals with reconnection of the local and foreign connections. | org.apache.activemq.network.jms.ReconnectionPolicy

redeliveryPlugin

Replace regular DLQ handling with redelivery via a resend to the original destination after a delay A destination matching RedeliveryPolicy controls the quantity and delay for re-sends If there is no matching policy or an existing policy limit is exceeded by default regular DLQ processing resumes. This is controlled via sendToDlqIfMaxRetriesExceeded and fallbackToDeadLetter

org.apache.activemq.broker.util.RedeliveryPlugin

redeliveryPolicy | Configuration options for a messageConsumer used to control how messages are re-delivered when they are rolled back. May be used server side on a per destination basis via the Broker RedeliveryPlugin | org.apache.activemq.RedeliveryPolicy
redeliveryPolicyMap | Represents a destination based configuration of policies so that individual destinations or wildcard hierarchies of destinations can be configured using different policies. | org.apache.activemq.broker.region.policy.RedeliveryPolicyMap
roundRobinDispatchPolicy | Simple dispatch policy that sends a message to every subscription that matches the message. | org.apache.activemq.broker.region.policy.RoundRobinDispatchPolicy
shared-file-locker | Represents an exclusive lock on a database to avoid multiple brokers running against the same logical database. | org.apache.activemq.store.SharedFileLocker
sharedDeadLetterStrategy | A default implementation of {@link DeadLetterStrategy} which uses a constant destination. | org.apache.activemq.broker.region.policy.SharedDeadLetterStrategy
simpleAuthenticationPlugin | Provides a simple authentication plugin | org.apache.activemq.security.SimpleAuthenticationPlugin
simpleAuthorizationMap | An AuthorizationMap which is configured with individual DestinationMaps for each operation. | org.apache.activemq.security.SimpleAuthorizationMap
simpleDispatchPolicy | Simple dispatch policy that sends a message to every subscription that matches the message. | org.apache.activemq.broker.region.policy.SimpleDispatchPolicy
simpleDispatchSelector | Simple dispatch policy that determines if a message can be sent to a subscription | org.apache.activemq.broker.region.policy.SimpleDispatchSelector
simpleJmsMessageConvertor | Converts Message from one JMS to another | org.apache.activemq.network.jms.SimpleJmsMessageConvertor
simpleMessageGroupMapFactory | A factory to create instances of {@link SimpleMessageGroupMap} when implementing the Message Groups functionality. | org.apache.activemq.broker.region.group.SimpleMessageGroupMapFactory
sslContext | Extends the SslContext so that it's easier to configure from spring. | org.apache.activemq.spring.SpringSslContext
statements |  | org.apache.activemq.store.jdbc.Statements

statisticsBrokerPlugin

A StatisticsBrokerPlugin You can retrieve a Map Message for a Destination - or Broker containing statistics as key-value pairs The message must contain a replyTo Destination - else its ignored To retrieve stats on the broker send a empty message to ActiveMQ.Statistics.Broker (Queue or Topic) With a replyTo set to the destination you want the stats returned to. To retrieve stats for a destination - e.g. foo - send an empty message to ActiveMQ.Statistics.Destination.foo - this works with wildcards to - you get a message for each wildcard match on the replyTo destination. The stats message is a MapMessage populated with statistics for the target

org.apache.activemq.plugin.StatisticsBrokerPlugin

storeCursor | Pending messages | org.apache.activemq.broker.region.policy.StorePendingQueueMessageStoragePolicy
storeDurableSubscriberCursor | Pending messages for a durable | org.apache.activemq.broker.region.policy.StorePendingDurableSubscriberMessageStoragePolicy
storeUsage | Used to keep track of how much of something is being used so that a productive working set usage can be controlled. Main use case is manage memory usage. | org.apache.activemq.usage.StoreUsage

streamJDBCAdapter

This JDBCAdapter inserts and extracts BLOB data using the setBinaryStream()/getBinaryStream() operations. The databases/JDBC drivers that use this adapter are:

- Axion

org.apache.activemq.store.jdbc.adapter.StreamJDBCAdapter

strictOrderDispatchPolicy | Dispatch policy that causes every subscription to see messages in the same order. | org.apache.activemq.broker.region.policy.StrictOrderDispatchPolicy
sybase-jdbc-adapter | A JDBC Adapter for Sybase databases | org.apache.activemq.store.jdbc.adapter.SybaseJDBCAdapter
systemUsage | Holder for Usage instances for memory, store and temp files Main use case is manage memory usage. | org.apache.activemq.usage.SystemUsage
taskRunnerFactory | Manages the thread pool for long running tasks. Long running tasks are not always active but when they are active, they may need a few iterations of processing for them to become idle. The manager ensures that each task is processes but that no one task overtakes the system. This is kinda like cooperative multitasking. | org.apache.activemq.thread.TaskRunnerFactory
tempDestinationAuthorizationEntry | Represents an entry in a {@link DefaultAuthorizationMap} for assigning different operations (read, write, admin) of user roles to a temporary destination | org.apache.activemq.security.TempDestinationAuthorizationEntry
tempQueue | An ActiveMQ Temporary Queue Destination | org.apache.activemq.command.ActiveMQTempQueue
tempTopic | An ActiveMQ Temporary Topic Destination | org.apache.activemq.command.ActiveMQTempTopic
tempUsage | Used to keep track of how much of something is being used so that a productive working set usage can be controlled. Main use case is manage memory usage. | org.apache.activemq.usage.TempUsage

timeStampingBrokerPlugin

A Broker interceptor which updates a JMS Client's timestamp on the message with a broker timestamp. Useful when the clocks on client machines are known to not be correct and you can only trust the time set on the broker machines. Enabling this plugin will break JMS compliance since the timestamp that the producer sees on the messages after as send() will be different from the timestamp the consumer will observe when he receives the message. This plugin is not enabled in the default ActiveMQ configuration. 2 new attributes have been added which will allow the administrator some override control over the expiration time for incoming messages: Attribute 'zeroExpirationOverride' can be used to apply an expiration time to incoming messages with no expiration defined (messages that would never expire) Attribute 'ttlCeiling' can be used to apply a limit to the expiration time

org.apache.activemq.broker.util.TimeStampingBrokerPlugin

timedSubscriptionRecoveryPolicy | This implementation of {@link SubscriptionRecoveryPolicy} will keep a timed buffer of messages around in memory and use that to recover new subscriptions. | org.apache.activemq.broker.region.policy.TimedSubscriptionRecoveryPolicy
topic | An ActiveMQ Topic | org.apache.activemq.command.ActiveMQTopic
traceBrokerPathPlugin | The TraceBrokerPathPlugin can be used in a network of Brokers. Each Broker that has the plugin configured, will add it's brokerName to the content of a JMS Property. If all Brokers have this property enabled, the path the message actually took through the network can be seen in the defined property. | org.apache.activemq.broker.util.TraceBrokerPathPlugin
transact-database-locker | Represents an exclusive lock on a database to avoid multiple brokers running against the same logical database. | org.apache.activemq.store.jdbc.adapter.TransactDatabaseLocker
transact-jdbc-adapter | A JDBC Adapter for Transact-SQL based databases such as SQL Server or Sybase | org.apache.activemq.store.jdbc.adapter.TransactJDBCAdapter
transportConnector |  | org.apache.activemq.broker.TransportConnector
udpTraceBrokerPlugin | A Broker interceptor which allows you to trace all operations to a UDP socket. | org.apache.activemq.broker.util.UDPTraceBrokerPlugin
uniquePropertyMessageEvictionStrategy | An eviction strategy which evicts the oldest message within messages with the same property value | org.apache.activemq.broker.region.policy.UniquePropertyMessageEvictionStrategy
usageCapacity | Identify if a limit has been reached | org.apache.activemq.usage.UsageCapacity
virtualDestinationInterceptor | Implements Virtual Topics. | org.apache.activemq.broker.region.virtual.VirtualDestinationInterceptor
virtualSelectorCacheBrokerPlugin | A plugin which allows the caching of the selector from a subscription queue. This stops the build-up of unwanted messages, especially when consumers may disconnect from time to time when using virtual destinations. This is influenced by code snippets developed by Maciej Rakowicz | org.apache.activemq.plugin.SubQueueSelectorCacheBrokerPlugin
virtualTopic | Creates Virtual Topics using a prefix and postfix. The virtual destination creates a wildcard that is then used to look up all active queue subscriptions which match. | org.apache.activemq.broker.region.virtual.VirtualTopic
vmCursor | Pending messages held | org.apache.activemq.broker.region.policy.VMPendingSubscriberMessageStoragePolicy
vmDurableCursor | Pending | org.apache.activemq.broker.region.policy.VMPendingDurableSubscriberMessageStoragePolicy
vmQueueCursor | Pending messages | org.apache.activemq.broker.region.policy.VMPendingQueueMessageStoragePolicy
xaConnectionFactory | A Spring enhanced XA connection factory which will automatically use the Spring bean name as the clientIDPrefix property so that connections created have client IDs related to your Spring.xml file for easier comprehension from JMX. | org.apache.activemq.spring.ActiveMQXAConnectionFactory

# Element Detail

## Element: abortSlowConsumerStrategy

Attribute | Type | Description
--- | --- | ---
abortConnection | xs:boolean | abort the consumers connection rather than sending a stop command to the remote consumer
checkPeriod | xs:long | time in milliseconds between checks for slow subscriptions
maxSlowCount | xs:long | number of times a subscription can be deemed slow before triggering abort effect depends on dispatch rate as slow determination is done on dispatch
maxSlowDuration | xs:long | time in milliseconds that a sub can remain slow before triggering an abort.
name | xs:string |

Element | Type | Description
--- | --- | ---
brokerService | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: amqPersistenceAdapter

Attribute | Type | Description
--- | --- | ---
archiveDataLogs | xs:boolean |
brokerName | xs:string |
checkpointInterval | xs:long |
cleanupInterval | xs:long |
directory | xs:string |
directoryArchive | xs:string |
disableLocking | xs:boolean |
forceRecoverReferenceStore | xs:boolean |
indexBinSize | xs:integer |
indexKeySize | xs:integer |
indexLoadFactor | xs:integer |
indexMaxBinSize | xs:integer |
indexPageSize | xs:string | When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
journalThreadPriority | xs:integer |
maxCheckpointMessageAddSize | xs:string | When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
maxFileLength | xs:string | When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
maxReferenceFileLength | xs:string | When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
persistentIndex | xs:boolean |
recoverReferenceStore | xs:boolean |
syncOnWrite | xs:boolean |
useDedicatedTaskRunner | xs:boolean |
useNio | xs:boolean |

Element | Type | Description
--- | --- | ---
asyncDataManager | <spring:bean/> |
brokerService | broker | brokerService |
referenceStoreAdapter | <spring:bean/> |
taskRunnerFactory | taskRunnerFactory |
usageManager | systemUsage |
wireFormat | <spring:bean/> |

## Element: amqPersistenceAdapterFactory

Attribute | Type | Description
--- | --- | ---
brokerName | xs:string |
checkpointInterval | xs:long |
cleanupInterval | xs:long |
dataDirectory | xs:string |
forceRecoverReferenceStore | xs:boolean |
indexBinSize | xs:integer |
indexKeySize | xs:integer |
indexLoadFactor | xs:integer |
indexMaxBinSize | xs:integer |
indexPageSize | xs:integer |
journalThreadPriority | xs:integer |
maxFileLength | xs:integer |
maxReferenceFileLength | xs:integer |
persistentIndex | xs:boolean |
recoverReferenceStore | xs:boolean |
syncOnTransaction | xs:boolean |
syncOnWrite | xs:boolean |
useDedicatedTaskRunner | xs:boolean |
useNio | xs:boolean |

Element | Type | Description
--- | --- | ---
referenceStoreAdapter | <spring:bean/> |
taskRunnerFactory | taskRunnerFactory |

## Element: authenticationUser

Attribute | Type | Description
--- | --- | ---
groups | xs:string |
password | xs:string |
username | xs:string |

## Element: authorizationEntry

Attribute | Type | Description
--- | --- | ---
admin | xs:string |
groupClass | xs:string |
queue | xs:string | A helper method to set the destination from a configuration file
read | xs:string |
tempQueue | xs:boolean |
tempTopic | xs:boolean |
topic | xs:string | A helper method to set the destination from a configuration file
write | xs:string |

Element | Type | Description
--- | --- | ---
adminACLs | (<spring:bean/>)* |
destination | queue | tempQueue | tempTopic | topic |
readACLs | (<spring:bean/>)* |
writeACLs | (<spring:bean/>)* |

## Element: authorizationMap

Element | Type | Description
--- | --- | ---
authorizationEntries | (<spring:bean/>)* | Sets the individual entries on the authorization map
defaultEntry | authorizationEntry | tempDestinationAuthorizationEntry |
entries | (<spring:bean/>)* | A helper method to allow the destination map to be populated from a dependency injection framework such as Spring
tempDestinationAuthorizationEntry | tempDestinationAuthorizationEntry |

## Element: authorizationPlugin

Element | Type | Description
--- | --- | ---
map | authorizationMap | cachedLDAPAuthorizationMap | lDAPAuthorizationMap | simpleAuthorizationMap |

## Element: axionJDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: blobJDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: broker

Attribute | Type | Description
--- | --- | ---
advisorySupport | xs:string | Allows the support of advisory messages to be disabled for performance reasons.
allowTempAutoCreationOnSend | xs:boolean | enable if temp destinations need to be propagated through a network when advisorySupport==false. This is used in conjunction with the policy gcInactiveDestinations for matching temps so they can get removed when inactive
brokerId | xs:string |
brokerName | xs:string | Sets the name of this broker; which must be unique in the network
brokerObjectName | xs:string | Sets the JMX ObjectName for this broker
cacheTempDestinations | xs:boolean |
consumerSystemUsagePortion | xs:integer |
dataDirectory | xs:string | Sets the directory in which the data files will be stored by default for the JDBC and Journal persistence adaptors.
dataDirectoryFile | xs:string | Sets the directory in which the data files will be stored by default for the JDBC and Journal persistence adaptors.
dedicatedTaskRunner | xs:boolean |
deleteAllMessagesOnStartup | xs:string | Sets whether or not all messages are deleted on startup - mostly only useful for testing.
enableStatistics | xs:boolean | Sets whether or not the Broker's services enable statistics or not.
keepDurableSubsActive | xs:boolean |
masterConnectorURI | xs:string |
maxPurgedDestinationsPerSweep | xs:integer |
mbeanInvocationTimeout | xs:long | Gets the time in Milliseconds that an invocation of an MBean method will wait before failing. The default value is to wait forever (zero).
monitorConnectionSplits | xs:boolean |
networkConnectorStartAsync | xs:boolean |
offlineDurableSubscriberTaskSchedule | xs:integer |
offlineDurableSubscriberTimeout | xs:integer |
passiveSlave | xs:string | Get the passiveSlave
persistenceThreadPriority | xs:integer |
persistent | xs:string | Sets whether or not persistence is enabled or disabled.
populateJMSXUserID | xs:boolean | Sets whether or not the broker should populate the JMSXUserID header.
populateUserNameInMBeans | xs:boolean | Should MBeans that support showing the Authenticated User Name information have this value filled in or not.
producerSystemUsagePortion | xs:integer |
schedulePeriodForDestinationPurge | xs:integer |
schedulerDirectory | xs:string |
schedulerDirectoryFile | xs:string |
schedulerSupport | xs:string |
shutdownOnMasterFailure | xs:boolean |
shutdownOnSlaveFailure | xs:string |
splitSystemUsageForProducersConsumers | xs:boolean |
start | xs:boolean | Sets whether or not the broker is started along with the ApplicationContext it is defined within. Normally you would want the broker to start up along with the ApplicationContext but sometimes when working with JUnit tests you may wish to start and stop the broker explicitly yourself.
startAsync | xs:boolean |
supportFailOver | xs:boolean |
systemExitOnShutdown | xs:string |
systemExitOnShutdownExitCode | xs:integer |
taskRunnerPriority | xs:integer |
timeBeforePurgeTempDestinations | xs:integer |
tmpDataDirectory | xs:string |
useAuthenticatedPrincipalForJMSXUserID | xs:boolean |
useJmx | xs:string | Sets whether or not the Broker's services should be exposed into JMX or not.
useLocalHostBrokerName | xs:boolean |
useLoggingForShutdownErrors | xs:boolean | Sets whether or not we should use commons-logging when reporting errors when shutting down the broker
useMirroredQueues | xs:boolean | Sets whether or not Mirrored Queues should be supported by default if they have not been explicitly configured.
useShutdownHook | xs:boolean | Sets whether or not we should use a shutdown handler to close down the broker cleanly if the JVM is terminated. It is recommended you leave this enabled.
useTempMirroredQueues | xs:boolean |
useVirtualTopics | xs:boolean | Sets whether or not Virtual Topics should be supported by default if they have not been explicitly configured.
vmConnectorURI | xs:string |
waitForSlave | xs:string |
waitForSlaveTimeout | xs:long |

Element | Type | Description
--- | --- | ---
adminView | <spring:bean/> | Returns the administration view of the broker; used to create and destroy resources such as queues and topics. Note this method returns null if JMX is disabled.
brokerContext | <spring:bean/> |
consumerSystemUsage | systemUsage |
destinationFactory | <spring:bean/> |
destinationInterceptors | (mirroredQueue | virtualDestinationInterceptor)* | Sets the destination interceptors to use
destinationPolicy | policyMap | Sets the destination specific policies available either for exact destinations or for wildcard areas of destinations.
destinations | (queue | tempQueue | tempTopic | topic)* | Sets the destinations which should be loaded/created on startup
ioExceptionHandler | defaultIOExceptionHandler | jDBCIOExceptionHandler | override the Default IOException handler, called when persistence adapter has experiences File or JDBC I/O Exceptions
jmsBridgeConnectors | (jmsQueueConnector | jmsTopicConnector)* |
managementContext | managementContext |
messageAuthorizationPolicy | <spring:bean/> | Sets the policy used to decide if the current connection is authorized to consume a given message
networkConnectorURIs | (<spring:bean/>)* |
networkConnectors | (ldapNetworkConnector | multicastNetworkConnector | networkConnector)* | Sets the network connectors which this broker will use to connect to other brokers in a federated network
persistenceAdapter | amqPersistenceAdapter | jdbcPersistenceAdapter | journalPersistenceAdapter | kahaDB | kahaPersistenceAdapter | levelDB | mKahaDB | memoryPersistenceAdapter | Sets the persistence adaptor implementation to use for this broker
persistenceFactory | amqPersistenceAdapterFactory | journalPersistenceAdapterFactory | journaledJDBC |
persistenceTaskRunnerFactory | taskRunnerFactory |

plugins

(authorizationPlugin | connectionDotFilePlugin | destinationDotFilePlugin | destinationPathSeparatorPlugin | discardingDLQBrokerPlugin | forcePersistencyModeBrokerPlugin | jaasAuthenticationPlugin | jaasCertificateAuthenticationPlugin | jaasDualAuthenticationPlugin | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | simpleAuthenticationPlugin | statisticsBrokerPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin | virtualSelectorCacheBrokerPlugin)*

Sets a number of broker plugins to install such as for security authentication or authorization

producerSystemUsage | systemUsage |
proxyConnectors | (<spring:bean/>)* | Sets the network connectors which this broker will use to connect to other brokers in a federated network
regionBroker | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

services

(broker | brokerService | commandAgent | database-locker | forwardingBridge | inboundQueueBridge | inboundTopicBridge | jdbcPersistenceAdapter | jmsQueueConnector | jmsTopicConnector | journalPersistenceAdapterFactory | journaledJDBC | kahaDB | ldapNetworkConnector | lease-database-locker | levelDB | managementContext | masterConnector | memoryUsage | multicastNetworkConnector | networkConnector | outboundQueueBridge | outboundTopicBridge | pListStore | proxyConnector | shared-file-locker | storeUsage | systemUsage | tempUsage | transact-database-locker)*

Sets the services associated with this broker such as a {@link MasterConnector}

shutdownHooks | (<spring:bean/>)* | Sets hooks to be executed when broker shut down
sslContext | sslContext |
systemUsage | systemUsage |
taskRunnerFactory | taskRunnerFactory |
tempDataStore | pListStore |
transportConnectorURIs | (<spring:bean/>)* |
transportConnectors | (transportConnector)* | Sets the transport connectors which this broker will listen on for new clients

## Element: brokerService

Attribute | Type | Description
--- | --- | ---
advisorySupport | xs:string | Allows the support of advisory messages to be disabled for performance reasons.
allowTempAutoCreationOnSend | xs:boolean | enable if temp destinations need to be propagated through a network when advisorySupport==false. This is used in conjunction with the policy gcInactiveDestinations for matching temps so they can get removed when inactive
brokerId | xs:string |
brokerName | xs:string | Sets the name of this broker; which must be unique in the network
brokerObjectName | xs:string | Sets the JMX ObjectName for this broker
cacheTempDestinations | xs:boolean |
consumerSystemUsagePortion | xs:integer |
dataDirectory | xs:string | Sets the directory in which the data files will be stored by default for the JDBC and Journal persistence adaptors.
dataDirectoryFile | xs:string | Sets the directory in which the data files will be stored by default for the JDBC and Journal persistence adaptors.
dedicatedTaskRunner | xs:boolean |
deleteAllMessagesOnStartup | xs:string | Sets whether or not all messages are deleted on startup - mostly only useful for testing.
enableStatistics | xs:boolean | Sets whether or not the Broker's services enable statistics or not.
keepDurableSubsActive | xs:boolean |
masterConnectorURI | xs:string |
maxPurgedDestinationsPerSweep | xs:integer |
mbeanInvocationTimeout | xs:long | Gets the time in Milliseconds that an invocation of an MBean method will wait before failing. The default value is to wait forever (zero).
monitorConnectionSplits | xs:boolean |
networkConnectorStartAsync | xs:boolean |
offlineDurableSubscriberTaskSchedule | xs:integer |
offlineDurableSubscriberTimeout | xs:integer |
passiveSlave | xs:string | Get the passiveSlave
persistenceThreadPriority | xs:integer |
persistent | xs:string | Sets whether or not persistence is enabled or disabled.
populateJMSXUserID | xs:boolean | Sets whether or not the broker should populate the JMSXUserID header.
populateUserNameInMBeans | xs:boolean | Should MBeans that support showing the Authenticated User Name information have this value filled in or not.
producerSystemUsagePortion | xs:integer |
schedulePeriodForDestinationPurge | xs:integer |
schedulerDirectory | xs:string |
schedulerDirectoryFile | xs:string |
schedulerSupport | xs:string |
shutdownOnMasterFailure | xs:boolean |
shutdownOnSlaveFailure | xs:string |
splitSystemUsageForProducersConsumers | xs:boolean |
startAsync | xs:boolean |
supportFailOver | xs:boolean |
systemExitOnShutdown | xs:string |
systemExitOnShutdownExitCode | xs:integer |
taskRunnerPriority | xs:integer |
timeBeforePurgeTempDestinations | xs:integer |
tmpDataDirectory | xs:string |
useAuthenticatedPrincipalForJMSXUserID | xs:boolean |
useJmx | xs:string | Sets whether or not the Broker's services should be exposed into JMX or not.
useLocalHostBrokerName | xs:boolean |
useLoggingForShutdownErrors | xs:boolean | Sets whether or not we should use commons-logging when reporting errors when shutting down the broker
useMirroredQueues | xs:boolean | Sets whether or not Mirrored Queues should be supported by default if they have not been explicitly configured.
useShutdownHook | xs:boolean | Sets whether or not we should use a shutdown handler to close down the broker cleanly if the JVM is terminated. It is recommended you leave this enabled.
useTempMirroredQueues | xs:boolean |
useVirtualTopics | xs:boolean | Sets whether or not Virtual Topics should be supported by default if they have not been explicitly configured.
vmConnectorURI | xs:string |
waitForSlave | xs:string |
waitForSlaveTimeout | xs:long |

Element | Type | Description
--- | --- | ---
adminView | <spring:bean/> | Returns the administration view of the broker; used to create and destroy resources such as queues and topics. Note this method returns null if JMX is disabled.
brokerContext | <spring:bean/> |
consumerSystemUsage | systemUsage |
destinationFactory | <spring:bean/> |
destinationInterceptors | (mirroredQueue | virtualDestinationInterceptor)* | Sets the destination interceptors to use
destinationPolicy | policyMap | Sets the destination specific policies available either for exact destinations or for wildcard areas of destinations.
destinations | (queue | tempQueue | tempTopic | topic)* | Sets the destinations which should be loaded/created on startup
ioExceptionHandler | defaultIOExceptionHandler | jDBCIOExceptionHandler | override the Default IOException handler, called when persistence adapter has experiences File or JDBC I/O Exceptions
jmsBridgeConnectors | (jmsQueueConnector | jmsTopicConnector)* |
managementContext | managementContext |
messageAuthorizationPolicy | <spring:bean/> | Sets the policy used to decide if the current connection is authorized to consume a given message
networkConnectorURIs | (<spring:bean/>)* |
networkConnectors | (ldapNetworkConnector | multicastNetworkConnector | networkConnector)* | Sets the network connectors which this broker will use to connect to other brokers in a federated network
persistenceAdapter | amqPersistenceAdapter | jdbcPersistenceAdapter | journalPersistenceAdapter | kahaDB | kahaPersistenceAdapter | levelDB | mKahaDB | memoryPersistenceAdapter | Sets the persistence adaptor implementation to use for this broker
persistenceFactory | amqPersistenceAdapterFactory | journalPersistenceAdapterFactory | journaledJDBC |
persistenceTaskRunnerFactory | taskRunnerFactory |

plugins

(authorizationPlugin | connectionDotFilePlugin | destinationDotFilePlugin | destinationPathSeparatorPlugin | discardingDLQBrokerPlugin | forcePersistencyModeBrokerPlugin | jaasAuthenticationPlugin | jaasCertificateAuthenticationPlugin | jaasDualAuthenticationPlugin | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | simpleAuthenticationPlugin | statisticsBrokerPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin | virtualSelectorCacheBrokerPlugin)*

Sets a number of broker plugins to install such as for security authentication or authorization

producerSystemUsage | systemUsage |
proxyConnectors | (<spring:bean/>)* | Sets the network connectors which this broker will use to connect to other brokers in a federated network
regionBroker | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

services

(broker | brokerService | commandAgent | database-locker | forwardingBridge | inboundQueueBridge | inboundTopicBridge | jdbcPersistenceAdapter | jmsQueueConnector | jmsTopicConnector | journalPersistenceAdapterFactory | journaledJDBC | kahaDB | ldapNetworkConnector | lease-database-locker | levelDB | managementContext | masterConnector | memoryUsage | multicastNetworkConnector | networkConnector | outboundQueueBridge | outboundTopicBridge | pListStore | proxyConnector | shared-file-locker | storeUsage | systemUsage | tempUsage | transact-database-locker)*

Sets the services associated with this broker such as a {@link MasterConnector}

shutdownHooks | (<spring:bean/>)* | Sets hooks to be executed when broker shut down
sslContext | sslContext |
systemUsage | systemUsage |
taskRunnerFactory | taskRunnerFactory |
tempDataStore | pListStore |
transportConnectorURIs | (<spring:bean/>)* |
transportConnectors | (transportConnector)* | Sets the transport connectors which this broker will listen on for new clients

## Element: bytesJDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: cachedLDAPAuthorizationMap

Attribute | Type | Description
--- | --- | ---
adminPermissionGroupSearchFilter | xs:string |
authentication | xs:string |
connectionPassword | xs:string |
connectionProtocol | xs:string |
connectionURL | xs:string |
connectionUsername | xs:string |
groupNameAttribute | xs:string |
groupObjectClass | xs:string |
legacyGroupMapping | xs:boolean |
permissionGroupMemberAttribute | xs:string |
queueSearchBase | xs:string |
readPermissionGroupSearchFilter | xs:string |
refreshDisabled | xs:boolean |
refreshInterval | xs:integer |
tempSearchBase | xs:string |
topicSearchBase | xs:string |
userNameAttribute | xs:string |
userObjectClass | xs:string |
writePermissionGroupSearchFilter | xs:string |

Element | Type | Description
--- | --- | ---
authorizationEntries | (<spring:bean/>)* | Sets the individual entries on the authorization map
defaultEntry | authorizationEntry | tempDestinationAuthorizationEntry |
entries | (<spring:bean/>)* | A helper method to allow the destination map to be populated from a dependency injection framework such as Spring
tempDestinationAuthorizationEntry | tempDestinationAuthorizationEntry |

## Element: commandAgent

Attribute | Type | Description
--- | --- | ---
brokerUrl | xs:string |
password | xs:string |
username | xs:string |

Element | Type | Description
--- | --- | ---
commandDestination | queue | tempQueue | tempTopic | topic |
connection | <spring:bean/> |
connectionFactory | connectionFactory | xaConnectionFactory |

## Element: compositeDemandForwardingBridge

Attribute | Type | Description
--- | --- | ---
createdByDuplex | xs:boolean |
mbeanObjectName | xs:string |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
configuration | ldapNetworkConnector | multicastNetworkConnector | networkConnector |
durableDestinations | (queue | tempQueue | tempTopic | topic)* |
dynamicallyIncludedDestinations | (queue | tempQueue | tempTopic | topic)* |
excludedDestinations | (queue | tempQueue | tempTopic | topic)* |
localBroker | <spring:bean/> |
networkBridgeListener | <spring:bean/> |
remoteBroker | <spring:bean/> |
staticallyIncludedDestinations | (queue | tempQueue | tempTopic | topic)* |

## Element: compositeQueue

Attribute | Type | Description
--- | --- | ---
copyMessage | xs:boolean | Sets whether a copy of the message will be sent to each destination. Defaults to true so that the forward destination is set as the destination of the message
forwardOnly | xs:boolean | Sets if the virtual destination is forward only (and so there is no physical queue to match the virtual queue) or if there is also a physical queue with the same name).
name | xs:string | Sets the name of this composite destination

Element | Type | Description
--- | --- | ---
forwardTo | (<spring:bean/>)* | Sets the list of destinations to forward to

## Element: compositeTopic

Attribute | Type | Description
--- | --- | ---
copyMessage | xs:boolean | Sets whether a copy of the message will be sent to each destination. Defaults to true so that the forward destination is set as the destination of the message
forwardOnly | xs:boolean | Sets if the virtual destination is forward only (and so there is no physical queue to match the virtual queue) or if there is also a physical queue with the same name).
name | xs:string | Sets the name of this composite destination

Element | Type | Description
--- | --- | ---
forwardTo | (<spring:bean/>)* | Sets the list of destinations to forward to

## Element: conditionalNetworkBridgeFilterFactory

Attribute | Type | Description
--- | --- | ---
rateDuration | xs:integer |
rateLimit | xs:integer |
replayDelay | xs:integer |
replayWhenNoConsumers | xs:boolean |

## Element: connectionDotFilePlugin

Attribute | Type | Description
--- | --- | ---
file | xs:string | Sets the destination file name to create the destination diagram

## Element: connectionFactory

Attribute | Type | Description
--- | --- | ---
alwaysSessionAsync | xs:boolean | If this flag is not set then a separate thread is not used for dispatching messages for each Session in the Connection. However, a separate thread is always used if there is more than one session, or the session isn't in auto acknowledge or duplicates ok mode. By default this value is set to true and session dispatch happens asynchronously.
alwaysSyncSend | xs:boolean | Set true if always require messages to be sync sent
auditDepth | xs:integer |
auditMaximumProducerNumber | xs:integer |
beanName | xs:string |
brokerURL | xs:string | Sets the connection URL used to connect to the ActiveMQ broker.
checkForDuplicates | xs:boolean |
clientID | xs:string | Sets the JMS clientID to use for the created connection. Note that this can only be used by one connection at once so generally its a better idea to set the clientID on a Connection
clientIDPrefix | xs:string | Sets the prefix used by autogenerated JMS Client ID values which are used if the JMS client does not explicitly specify on.
closeTimeout | xs:integer | Sets the timeout before a close is considered complete. Normally a close() on a connection waits for confirmation from the broker; this allows that operation to timeout to save the client hanging if there is no broker
connectionIDPrefix | xs:string | Sets the prefix used by connection id generator
consumerFailoverRedeliveryWaitPeriod | xs:long |
copyMessageOnSend | xs:boolean | Should a JMS message be copied to a new JMS Message object as part of the send() method in JMS. This is enabled by default to be compliant with the JMS specification. You can disable it if you do not mutate JMS messages after they are sent for a performance boost
disableTimeStampsByDefault | xs:boolean | Sets whether or not timestamps on messages should be disabled or not. If you disable them it adds a small performance boost.

dispatchAsync

xs:boolean

Enables or disables the default setting of whether or not consumers have their messages dispatched synchronously or asynchronously by the broker. For non-durable topics for example we typically dispatch synchronously by default to minimize context switches which boost performance. However sometimes its better to go slower to ensure that a single blocked consumer socket does not block delivery to other consumers.

exclusiveConsumer | xs:boolean | Enables or disables whether or not queue consumers should be exclusive or not for example to preserve ordering when not using Message Groups
maxThreadPoolSize | xs:integer |
messagePrioritySupported | xs:boolean |
nestedMapAndListEnabled | xs:boolean | Enables/disables whether or not Message properties and MapMessage entries support Nested Structures of Map and List objects
nonBlockingRedelivery | xs:boolean | When true a MessageConsumer will not stop Message delivery before re-delivering Messages from a rolled back transaction. This implies that message order will not be preserved and also will result in the TransactedIndividualAck option to be enabled.
objectMessageSerializationDefered | xs:boolean | When an object is set on an ObjectMessage, the JMS spec requires the object to be serialized by that set method. Enabling this flag causes the object to not get serialized. The object may subsequently get serialized if the message needs to be sent over a socket or stored to disk.
optimizeAcknowledge | xs:boolean |
optimizeAcknowledgeTimeOut | xs:long | The max time in milliseconds between optimized ack batches
optimizedAckScheduledAckInterval | xs:long | Gets the configured time interval that is used to force all MessageConsumers that have optimizedAcknowledge enabled to send an ack for any outstanding Message Acks. By default this value is set to zero meaning that the consumers will not do any background Message acknowledgment.
optimizedMessageDispatch | xs:boolean | If this flag is set then an larger prefetch limit is used - only applicable for durable topic subscribers.
password | xs:string | Sets the JMS password used for connections created from this factory
producerWindowSize | xs:integer |
sendAcksAsync | xs:boolean |
sendTimeout | xs:integer |
statsEnabled | xs:boolean |
transactedIndividualAck | xs:boolean | when true, submit individual transacted acks immediately rather than with transaction completion. This allows the acks to represent delivery status which can be persisted on rollback Used in conjunction with org.apache.activemq.store.kahadb.KahaDBPersistenceAdapter#setRewriteOnRedelivery(boolean) true
useAsyncSend | xs:boolean | Forces the use of Async Sends which adds a massive performance boost; but means that the send() method will return immediately whether the message has been sent or not which could lead to message loss.
useBeanNameAsClientIdPrefix | xs:boolean |
useCompression | xs:boolean | Enables the use of compression of the message bodies
useDedicatedTaskRunner | xs:boolean |
useRetroactiveConsumer | xs:boolean | Sets whether or not retroactive consumers are enabled. Retroactive consumers allow non-durable topic subscribers to receive old messages that were published before the non-durable subscriber started.
userName | xs:string | Sets the JMS userName used by connections created by this factory

warnAboutUnstartedConnectionTimeout

xs:long

Enables the timeout from a connection creation to when a warning is generated if the connection is not properly started via {@link Connection#start()} and a message is received by a consumer. It is a very common gotcha to forget to start the connection so this option makes the default case to create a warning if the user forgets. To disable the warning just set the value to < 0 (say -1).

watchTopicAdvisories | xs:boolean |

Element | Type | Description
--- | --- | ---
blobTransferPolicy | <spring:bean/> | Sets the policy used to describe how out-of-band BLOBs (Binary Large OBjects) are transferred from producers to brokers to consumers
clientIdGenerator | <spring:bean/> |

clientInternalExceptionListener

<spring:bean/>

Allows an {@link ClientInternalExceptionListener} to be configured on the ConnectionFactory so that when this factory is used by frameworks which don't expose the Connection such as Spring JmsTemplate, you can register an exception listener.

Note: access to this clientInternalExceptionListener will not be serialized if it is associated with more than on connection (as it will be if more than one connection is subsequently created by this connection factory)

connectionIdGenerator | <spring:bean/> |

exceptionListener

commandAgent

Allows an {@link ExceptionListener} to be configured on the ConnectionFactory so that when this factory is used by frameworks which don't expose the Connection such as Spring JmsTemplate, you can register an exception listener.

Note: access to this exceptionLinstener will not be serialized if it is associated with more than on connection (as it will be if more than one connection is subsequently created by this connection factory)

prefetchPolicy | prefetchPolicy | Sets the prefetch policy for consumers created by this connection.
properties | <spring:bean/> | Get the properties from this instance for storing in JNDI
redeliveryPolicy | redeliveryPolicy | Sets the global default redelivery policy to be used when a message is delivered but the session is rolled back
redeliveryPolicyMap | redeliveryPolicyMap | Sets the global redelivery policy mapping to be used when a message is delivered but the session is rolled back
rejectedTaskHandler | <spring:bean/> |
sessionTaskRunner | taskRunnerFactory |
transformer | <spring:bean/> | Sets the transformer used to transform messages before they are sent on to the JMS bus or when they are received from the bus but before they are delivered to the JMS client
transportListener | <spring:bean/> | Allows a listener to be configured on the ConnectionFactory so that when this factory is used with frameworks which don't expose the Connection such as Spring JmsTemplate, you can still register a transport listener.

## Element: constantPendingMessageLimitStrategy

Attribute | Type | Description
--- | --- | ---
limit | xs:integer |

## Element: database-locker

Attribute | Type | Description
--- | --- | ---
failIfLocked | xs:boolean |
lockAcquireSleepInterval | xs:long |
name | xs:string |
queryTimeout | xs:integer |

Element | Type | Description
--- | --- | ---
exceptionHandler | <spring:bean/> |

## Element: db2JDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: defaultIOExceptionHandler

Attribute | Type | Description
--- | --- | ---
ignoreAllErrors | xs:boolean |
ignoreNoSpaceErrors | xs:boolean |
ignoreSQLExceptions | xs:boolean |
noSpaceMessage | xs:string |
resumeCheckSleepPeriod | xs:long |
sqlExceptionMessage | xs:string |
stopStartConnectors | xs:boolean |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |

## Element: defaultJDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: defaultNetworkBridgeFilterFactory

## Element: defaultUsageCapacity

Attribute | Type | Description
--- | --- | ---
limit | xs:long |

## Element: demandForwardingBridge

Attribute | Type | Description
--- | --- | ---
createdByDuplex | xs:boolean |
mbeanObjectName | xs:string |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
configuration | ldapNetworkConnector | multicastNetworkConnector | networkConnector |
durableDestinations | (queue | tempQueue | tempTopic | topic)* |
dynamicallyIncludedDestinations | (queue | tempQueue | tempTopic | topic)* |
excludedDestinations | (queue | tempQueue | tempTopic | topic)* |
localBroker | <spring:bean/> |
networkBridgeListener | <spring:bean/> |
remoteBroker | <spring:bean/> |
staticallyIncludedDestinations | (queue | tempQueue | tempTopic | topic)* |

## Element: destinationDotFilePlugin

Attribute | Type | Description
--- | --- | ---
file | xs:string | Sets the destination file name to create the destination diagram

## Element: destinationEntry

Attribute | Type | Description
--- | --- | ---
queue | xs:string | A helper method to set the destination from a configuration file
tempQueue | xs:boolean |
tempTopic | xs:boolean |
topic | xs:string | A helper method to set the destination from a configuration file

Element | Type | Description
--- | --- | ---
destination | queue | tempQueue | tempTopic | topic |
value | authorizationEntry | destinationEntry | filteredKahaDB | policyEntry | redeliveryPolicy | tempDestinationAuthorizationEntry |

## Element: destinationPathSeparatorPlugin

Attribute | Type | Description
--- | --- | ---
pathSeparator | xs:string |

Element | Type | Description
--- | --- | ---
adminConnectionContext | <spring:bean/> |
next | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: discardingDLQBrokerPlugin

Attribute | Type | Description
--- | --- | ---
dropAll | xs:boolean |
dropOnly | xs:string |
dropTemporaryQueues | xs:boolean |
dropTemporaryTopics | xs:boolean |
reportInterval | xs:integer |

## Element: fileCursor

## Element: fileDurableSubscriberCursor

## Element: fileQueueCursor

## Element: filteredDestination

Attribute | Type | Description
--- | --- | ---
queue | xs:string | Sets the destination property to the given queue name
selector | xs:string | Sets the JMS selector used to filter messages before forwarding them to this destination
topic | xs:string | Sets the destination property to the given topic name

Element | Type | Description
--- | --- | ---
destination | queue | tempQueue | tempTopic | topic | The destination to send messages to if they match the filter
filter | <spring:bean/> |

## Element: filteredKahaDB

Attribute | Type | Description
--- | --- | ---
perDestination | xs:boolean |
queue | xs:string | A helper method to set the destination from a configuration file
tempQueue | xs:boolean |
tempTopic | xs:boolean |
topic | xs:string | A helper method to set the destination from a configuration file

Element | Type | Description
--- | --- | ---
adapter | kahaDB |
destination | queue | tempQueue | tempTopic | topic |
persistenceAdapter | kahaDB |

## Element: fixedCountSubscriptionRecoveryPolicy

Attribute | Type | Description
--- | --- | ---
maximumSize | xs:integer | Sets the maximum number of messages that this destination will hold around in RAM

Element | Type | Description
--- | --- | ---
broker | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: fixedSizedSubscriptionRecoveryPolicy

Attribute | Type | Description
--- | --- | ---
maximumSize | xs:integer | Sets the maximum amount of RAM in bytes that this buffer can hold in RAM
useSharedBuffer | xs:boolean |

Element | Type | Description
--- | --- | ---
broker | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |
buffer | <spring:bean/> |

## Element: forcePersistencyModeBroker

Attribute | Type | Description
--- | --- | ---
persistenceFlag | xs:boolean |

Element | Type | Description
--- | --- | ---
adminConnectionContext | <spring:bean/> |
next | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: forcePersistencyModeBrokerPlugin

Attribute | Type | Description
--- | --- | ---
persistenceFlag | xs:boolean | Sets the persistency mode.

## Element: forwardingBridge

Attribute | Type | Description
--- | --- | ---
clientId | xs:string |
destinationFilter | xs:string |
dispatchAsync | xs:boolean |
prefetchSize | xs:integer |
useCompression | xs:boolean |

Element | Type | Description
--- | --- | ---
localBroker | <spring:bean/> |
networkBridgeFailedListener | <spring:bean/> |
remoteBroker | <spring:bean/> |

## Element: hsqldb-jdbc-adapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: imageBasedJDBCAdaptor

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: inboundQueueBridge

Attribute | Type | Description
--- | --- | ---
doHandleReplyTo | xs:boolean |
inboundQueueName | xs:string | Sets the queue name used for the inbound queue, if the outbound queue name has not been set, then this method uses the same name to configure the outbound queue name.
localQueueName | xs:string |
selector | xs:string |

Element | Type | Description
--- | --- | ---
consumer | <spring:bean/> |
consumerConnection | <spring:bean/> |
consumerQueue | queue |
jmsConnector | jmsQueueConnector | jmsTopicConnector |
jmsMessageConvertor | simpleJmsMessageConvertor |
producerConnection | <spring:bean/> |
producerQueue | queue |

## Element: inboundTopicBridge

Attribute | Type | Description
--- | --- | ---
consumerName | xs:string |
doHandleReplyTo | xs:boolean |
inboundTopicName | xs:string | Sets the topic name used for the inbound topic, if the outbound topic name has not been set, then this method uses the same name to configure the outbound topic name.
localTopicName | xs:string |
selector | xs:string |

Element | Type | Description
--- | --- | ---
consumer | <spring:bean/> |
consumerConnection | <spring:bean/> |
consumerTopic | topic |
jmsConnector | jmsQueueConnector | jmsTopicConnector |
jmsMessageConvertor | simpleJmsMessageConvertor |
producerConnection | <spring:bean/> |
producerTopic | topic |

## Element: individualDeadLetterStrategy

Attribute | Type | Description
--- | --- | ---
destinationPerDurableSubscriber | xs:boolean | sets whether durable topic subscriptions are to get individual dead letter destinations. When true, the DLQ is of the form 'topicPrefix.clientId:subscriptionName' The default is false.
enableAudit | xs:boolean |
processExpired | xs:boolean |
processNonPersistent | xs:boolean |
queuePrefix | xs:string | Sets the prefix to use for all dead letter queues for queue messages
queueSuffix | xs:string | Sets the suffix to use for all dead letter queues for queue messages
topicPrefix | xs:string | Sets the prefix to use for all dead letter queues for topic messages
topicSuffix | xs:string | Sets the suffix to use for all dead letter queues for topic messages
useQueueForQueueMessages | xs:boolean | Sets whether a queue or topic should be used for queue messages sent to a DLQ. The default is to use a Queue
useQueueForTopicMessages | xs:boolean | Sets whether a queue or topic should be used for topic messages sent to a DLQ. The default is to use a Queue

## Element: informixJDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: jDBCIOExceptionHandler

Attribute | Type | Description
--- | --- | ---
ignoreAllErrors | xs:boolean |
ignoreNoSpaceErrors | xs:boolean |
ignoreSQLExceptions | xs:boolean |
noSpaceMessage | xs:string |
resumeCheckSleepPeriod | xs:long |
sqlExceptionMessage | xs:string |
stopStartConnectors | xs:boolean |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |

## Element: jaasAuthenticationPlugin

Attribute | Type | Description
--- | --- | ---
configuration | xs:string | Sets the JAAS configuration domain name used
discoverLoginConfig | xs:boolean | Enables or disables the auto-discovery of the login.config file for JAAS to initialize itself. This flag is enabled by default such that if the java.security.auth.login.config system property is not defined then it is set to the location of the login.config file on the classpath.

## Element: jaasCertificateAuthenticationPlugin

Attribute | Type | Description
--- | --- | ---
configuration | xs:string | Sets the JAAS configuration domain name used
discoverLoginConfig | xs:boolean | Enables or disables the auto-discovery of the login.config file for JAAS to initialize itself. This flag is enabled by default such that if the java.security.auth.login.config system property is not defined then it is set to the location of the login.config file on the classpath.

## Element: jaasDualAuthenticationPlugin

Attribute | Type | Description
--- | --- | ---
configuration | xs:string | Sets the JAAS configuration domain name used
discoverLoginConfig | xs:boolean | Enables or disables the auto-discovery of the login.config file for JAAS to initialize itself. This flag is enabled by default such that if the java.security.auth.login.config system property is not defined then it is set to the location of the login.config file on the classpath.
sslConfiguration | xs:string | Set the JAAS SSL configuration domain

## Element: jdbcPersistenceAdapter

Attribute | Type | Description
--- | --- | ---
auditRecoveryDepth | xs:integer |
brokerName | xs:string |
cleanupPeriod | xs:integer | Sets the number of milliseconds until the database is attempted to be cleaned up for durable topics
createTablesOnStartup | xs:boolean | Sets whether or not tables are created on startup
dataDirectory | xs:string |
dataDirectoryFile | xs:string |
directory | xs:string |
enableAudit | xs:boolean |
lockAcquireSleepInterval | xs:long |
lockKeepAlivePeriod | xs:long |
maxAuditDepth | xs:integer |
maxProducersToAudit | xs:integer |
maxRows | xs:integer |
transactionIsolation | xs:integer | set the Transaction isolation level to something other that TRANSACTION_READ_UNCOMMITTED This allowable dirty isolation level may not be achievable in clustered DB environments so a more restrictive and expensive option may be needed like TRANSACTION_REPEATABLE_READ see isolation level constants in {@link java.sql.Connection}
useDatabaseLock | xs:boolean |
useExternalMessageReferences | xs:boolean |
useLock | xs:boolean |

Element | Type | Description
--- | --- | ---
adapter | axionJDBCAdapter | blobJDBCAdapter | bytesJDBCAdapter | db2JDBCAdapter | defaultJDBCAdapter | hsqldb-jdbc-adapter | imageBasedJDBCAdaptor | informixJDBCAdapter | maxdb-jdbc-adapter | mysql-jdbc-adapter | oracleBlobJDBCAdapter | oracleJDBCAdapter | postgresql-jdbc-adapter | streamJDBCAdapter | sybase-jdbc-adapter | transact-jdbc-adapter |
brokerService | broker | brokerService |
dataSource | <spring:bean/> |
databaseLocker | database-locker | lease-database-locker | shared-file-locker | transact-database-locker | Sets the database locker strategy to use to lock the database on startup
ds | <spring:bean/> |
lockDataSource | <spring:bean/> |
locker | database-locker | lease-database-locker | shared-file-locker | transact-database-locker |
scheduledThreadPoolExecutor | <spring:bean/> |
statements | statements |
usageManager | systemUsage |
wireFormat | <spring:bean/> |

## Element: jmsQueueConnector

Attribute | Type | Description
--- | --- | ---
jndiLocalTemplate | xs:string |
jndiOutboundTemplate | xs:string |
localClientId | xs:string |
localConnectionFactoryName | xs:string |
localPassword | xs:string |
localUsername | xs:string |
name | xs:string |
outboundClientId | xs:string |
outboundPassword | xs:string |
outboundQueueConnectionFactoryName | xs:string |
outboundUsername | xs:string |
preferJndiDestinationLookup | xs:boolean | Sets whether the connector should prefer to first try to find a destination in JNDI before using JMS semantics to create a Destination. By default the connector will first use JMS semantics and then fall-back to JNDI lookup, setting this value to true will reverse that ordering.
replyToDestinationCacheSize | xs:integer |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService | One way to configure the local connection - this is called by The BrokerService when the Connector is embedded
inboundMessageConvertor | simpleJmsMessageConvertor |
inboundQueueBridges | (inboundQueueBridge)* |
localQueueConnection | <spring:bean/> |
localQueueConnectionFactory | connectionFactory | xaConnectionFactory |
outboundMessageConvertor | simpleJmsMessageConvertor |
outboundQueueBridges | (outboundQueueBridge)* |
outboundQueueConnection | <spring:bean/> |
outboundQueueConnectionFactory | connectionFactory | xaConnectionFactory |
reconnectionPolicy | reconnectionPolicy |

## Element: jmsTopicConnector

Attribute | Type | Description
--- | --- | ---
jndiLocalTemplate | xs:string |
jndiOutboundTemplate | xs:string |
localClientId | xs:string |
localConnectionFactoryName | xs:string |
localPassword | xs:string |
localUsername | xs:string |
name | xs:string |
outboundClientId | xs:string |
outboundPassword | xs:string |
outboundTopicConnectionFactoryName | xs:string |
outboundUsername | xs:string |
preferJndiDestinationLookup | xs:boolean | Sets whether the connector should prefer to first try to find a destination in JNDI before using JMS semantics to create a Destination. By default the connector will first use JMS semantics and then fall-back to JNDI lookup, setting this value to true will reverse that ordering.
replyToDestinationCacheSize | xs:integer |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService | One way to configure the local connection - this is called by The BrokerService when the Connector is embedded
inboundMessageConvertor | simpleJmsMessageConvertor |
inboundTopicBridges | (inboundTopicBridge)* |
localTopicConnection | <spring:bean/> |
localTopicConnectionFactory | connectionFactory | xaConnectionFactory |
outboundMessageConvertor | simpleJmsMessageConvertor |
outboundTopicBridges | (outboundTopicBridge)* |
outboundTopicConnection | <spring:bean/> |
outboundTopicConnectionFactory | connectionFactory | xaConnectionFactory |
reconnectionPolicy | reconnectionPolicy |

## Element: journalPersistenceAdapter

Attribute | Type | Description
--- | --- | ---
brokerName | xs:string |
directory | xs:string |
maxCheckpointMessageAddSize | xs:integer |
maxCheckpointWorkers | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
journal | <spring:bean/> |
longTermPersistence | amqPersistenceAdapter | jdbcPersistenceAdapter | journalPersistenceAdapter | kahaDB | kahaPersistenceAdapter | levelDB | mKahaDB | memoryPersistenceAdapter |
persistenceAdapter | amqPersistenceAdapter | jdbcPersistenceAdapter | journalPersistenceAdapter | kahaDB | kahaPersistenceAdapter | levelDB | mKahaDB | memoryPersistenceAdapter |
taskRunnerFactory | taskRunnerFactory |
usageManager | systemUsage |

## Element: journalPersistenceAdapterFactory

Attribute | Type | Description
--- | --- | ---
createTablesOnStartup | xs:boolean | Sets whether or not tables are created on startup
dataDirectory | xs:string |
dataDirectoryFile | xs:string |
journalArchiveDirectory | xs:string |
journalLogFileSize | xs:string | Sets the size of the journal log files When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
journalLogFiles | xs:integer | Sets the number of journal log files to use
journalThreadPriority | xs:integer | Sets the thread priority of the journal thread
lockKeepAlivePeriod | xs:long |
useDatabaseLock | xs:boolean | Sets whether or not an exclusive database lock should be used to enable JDBC Master/Slave. Enabled by default.
useDedicatedTaskRunner | xs:boolean |
useJournal | xs:boolean | Enables or disables the use of the journal. The default is to use the journal
useLock | xs:boolean |
useQuickJournal | xs:boolean | Enables or disables the use of quick journal, which keeps messages in the journal and just stores a reference to the messages in JDBC. Defaults to false so that messages actually reside long term in the JDBC database.

Element | Type | Description
--- | --- | ---
adapter | axionJDBCAdapter | blobJDBCAdapter | bytesJDBCAdapter | db2JDBCAdapter | defaultJDBCAdapter | hsqldb-jdbc-adapter | imageBasedJDBCAdaptor | informixJDBCAdapter | maxdb-jdbc-adapter | mysql-jdbc-adapter | oracleBlobJDBCAdapter | oracleJDBCAdapter | postgresql-jdbc-adapter | streamJDBCAdapter | sybase-jdbc-adapter | transact-jdbc-adapter |
brokerService | broker | brokerService |
dataSource | <spring:bean/> |
jdbcAdapter | jdbcPersistenceAdapter |
journal | <spring:bean/> |
locker | database-locker | lease-database-locker | shared-file-locker | transact-database-locker |
statements | statements |
taskRunnerFactory | taskRunnerFactory |

## Element: journaledJDBC

Attribute | Type | Description
--- | --- | ---
createTablesOnStartup | xs:boolean | Sets whether or not tables are created on startup
dataDirectory | xs:string |
dataDirectoryFile | xs:string |
journalArchiveDirectory | xs:string |
journalLogFileSize | xs:string | Sets the size of the journal log files When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
journalLogFiles | xs:integer | Sets the number of journal log files to use
journalThreadPriority | xs:integer | Sets the thread priority of the journal thread
lockKeepAlivePeriod | xs:long |
useDatabaseLock | xs:boolean | Sets whether or not an exclusive database lock should be used to enable JDBC Master/Slave. Enabled by default.
useDedicatedTaskRunner | xs:boolean |
useJournal | xs:boolean | Enables or disables the use of the journal. The default is to use the journal
useLock | xs:boolean |
useQuickJournal | xs:boolean | Enables or disables the use of quick journal, which keeps messages in the journal and just stores a reference to the messages in JDBC. Defaults to false so that messages actually reside long term in the JDBC database.

Element | Type | Description
--- | --- | ---
adapter | axionJDBCAdapter | blobJDBCAdapter | bytesJDBCAdapter | db2JDBCAdapter | defaultJDBCAdapter | hsqldb-jdbc-adapter | imageBasedJDBCAdaptor | informixJDBCAdapter | maxdb-jdbc-adapter | mysql-jdbc-adapter | oracleBlobJDBCAdapter | oracleJDBCAdapter | postgresql-jdbc-adapter | streamJDBCAdapter | sybase-jdbc-adapter | transact-jdbc-adapter |
brokerService | broker | brokerService |
dataSource | <spring:bean/> |
jdbcAdapter | jdbcPersistenceAdapter |
journal | <spring:bean/> |
locker | database-locker | lease-database-locker | shared-file-locker | transact-database-locker |
statements | statements |
taskRunnerFactory | taskRunnerFactory |

## Element: kahaDB

Attribute | Type | Description
--- | --- | ---
archiveCorruptedIndex | xs:boolean |
archiveDataLogs | xs:boolean |
brokerName | xs:string |
checkForCorruptJournalFiles | xs:boolean |
checkpointInterval | xs:long | Get the checkpointInterval
checksumJournalFiles | xs:boolean |
cleanupInterval | xs:long | Get the cleanupInterval
concurrentStoreAndDispatchQueues | xs:boolean |
concurrentStoreAndDispatchTopics | xs:boolean |
databaseLockedWaitDelay | xs:integer |
directory | xs:string | Get the directory
directoryArchive | xs:string |
enableIndexDiskSyncs | xs:boolean |
enableIndexPageCaching | xs:boolean |
enableIndexRecoveryFile | xs:boolean |
enableIndexWriteAsync | xs:boolean | Get the enableIndexWriteAsync
enableJournalDiskSyncs | xs:boolean | Get the enableJournalDiskSyncs
failoverProducersAuditDepth | xs:integer | set the audit window depth for duplicate suppression (should exceed the max transaction batch)
forceRecoverIndex | xs:boolean |
ignoreMissingJournalfiles | xs:boolean | Get the ignoreMissingJournalfiles
indexCacheSize | xs:string | Get the indexCacheSize
indexLFUEvictionFactor | xs:float |
indexWriteBatchSize | xs:string | Get the indexWriteBatchSize
journalMaxFileLength | xs:string | Get the journalMaxFileLength
journalMaxWriteBatchSize | xs:string | Get the journalMaxWriteBatchSize
lockKeepAlivePeriod | xs:long |
maxAsyncJobs | xs:integer |
maxFailoverProducersToTrack | xs:integer | Set the max number of producers (LRU cache) to track for duplicate sends
rewriteOnRedelivery | xs:boolean | When true, persist the redelivery status such that the message redelivery flag can survive a broker failure used with org.apache.activemq.ActiveMQConnectionFactory#setTransactedIndividualAck(boolean) true
useIndexLFRUEviction | xs:boolean |
useLock | xs:boolean |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
locker | database-locker | lease-database-locker | shared-file-locker | transact-database-locker |
usageManager | systemUsage |

## Element: kahaPersistenceAdapter

Attribute | Type | Description
--- | --- | ---
brokerName | xs:string |
directory | xs:string |
maxDataFileLength | xs:string | When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
persistentIndex | xs:boolean |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
size | <spring:bean/> |
usageManager | systemUsage |

## Element: lDAPAuthorizationMap

Attribute | Type | Description
--- | --- | ---
adminAttribute | xs:string |
adminBase | xs:string |
advisorySearchBase | xs:string |
authentication | xs:string |
connectionPassword | xs:string |
connectionProtocol | xs:string |
connectionURL | xs:string |
connectionUsername | xs:string |
initialContextFactory | xs:string |
queueSearchSubtreeBool | xs:boolean |
readAttribute | xs:string |
readBase | xs:string |
tempSearchBase | xs:string |
topicSearchSubtreeBool | xs:boolean |
useAdvisorySearchBase | xs:boolean |
writeAttribute | xs:string |
writeBase | xs:string |

Element | Type | Description
--- | --- | ---
context | <spring:bean/> |
options | <spring:bean/> |
queueSearchMatchingFormat | <spring:bean/> |
topicSearchMatchingFormat | <spring:bean/> |

## Element: lastImageSubscriptionRecoveryPolicy

Element | Type | Description
--- | --- | ---
broker | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: ldapNetworkConnector

Attribute | Type | Description
--- | --- | ---
alwaysSyncSend | xs:boolean |
anonymousAuthentication | xs:boolean | sets LDAP anonymous authentication access credentials
base | xs:string | sets the base LDAP dn used for lookup operations
bridgeTempDestinations | xs:boolean |
brokerName | xs:string |
brokerURL | xs:string |
conduitSubscriptions | xs:boolean |
consumerPriorityBase | xs:integer |
decreaseNetworkConsumerPriority | xs:boolean |
destinationFilter | xs:string |
dispatchAsync | xs:boolean |
duplex | xs:boolean |
dynamicOnly | xs:boolean |
localUri | xs:string |
name | xs:string |
networkTTL | xs:integer |
objectName | xs:string |
password | xs:string | sets the LDAP password for access credentials
prefetchSize | xs:string |
searchEventListener | xs:boolean | enables/disable a persistent search to the LDAP server as defined in draft-ietf-ldapext-psearch-03.txt (2.16.840.1.113730.3.4.3)
searchFilter | xs:string | sets the LDAP search filter as defined in RFC 2254
searchScope | xs:string | sets the LDAP search scope
staticBridge | xs:boolean |
suppressDuplicateQueueSubscriptions | xs:boolean |
suppressDuplicateTopicSubscriptions | xs:boolean |
uri | xs:string | returns the next URI from the configured list
useCompression | xs:boolean |
user | xs:string | sets the LDAP user for access credentials
userName | xs:string |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
connectionFilter | <spring:bean/> |
durableDestinations | (<spring:bean/>)* |
dynamicallyIncludedDestinations | (<spring:bean/>)* |
excludedDestinations | (<spring:bean/>)* |
staticallyIncludedDestinations | (<spring:bean/>)* |

## Element: lease-database-locker

Attribute | Type | Description
--- | --- | ---
failIfLocked | xs:boolean |
leaseHolderId | xs:string |
lockAcquireSleepInterval | xs:long |
maxAllowableDiffFromDBTime | xs:integer |
name | xs:string |
queryTimeout | xs:integer |

## Element: levelDB

Attribute | Type | Description
--- | --- | ---
asyncBufferSize | xs:integer |
brokerName | xs:string |
directory | xs:string |
failIfLocked | xs:boolean |
flushDelay | xs:integer |
indexBlockRestartInterval | xs:integer |
indexBlockSize | xs:integer |
indexCacheSize | xs:long |
indexCompression | xs:string |
indexFactory | xs:string |
indexMaxOpenFiles | xs:integer |
indexWriteBufferSize | xs:integer |
logCompression | xs:string |
logDirectory | xs:string |
logSize | xs:long |
monitorStats | xs:boolean |
paranoidChecks | xs:boolean |
sync | xs:boolean |
verifyChecksums | xs:boolean |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
usageManager | systemUsage |

## Element: loggingBrokerPlugin

Attribute | Type | Description
--- | --- | ---
logAll | xs:boolean | Logger all Events that go through the Plugin
logConnectionEvents | xs:boolean | Logger Events that are related to connections
logConsumerEvents | xs:boolean | Logger Events that are related to Consumers
logInternalEvents | xs:boolean | Logger Events that are normally internal to the broker
logMessageEvents | xs:boolean | Logger Events that are related to message processing
logProducerEvents | xs:boolean | Logger Events that are related to Producers
logSessionEvents | xs:boolean | Logger Events that are related to sessions
logTransactionEvents | xs:boolean | Logger Events that are related to transaction processing

Element | Type | Description
--- | --- | ---
adminConnectionContext | <spring:bean/> |
next | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: mKahaDB

Attribute | Type | Description
--- | --- | ---
brokerName | xs:string |
directory | xs:string |
journalMaxFileLength | xs:string | Set the max file length of the transaction journal When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
journalWriteBatchSize | xs:string | Set the max write batch size of the transaction journal When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
entries | (<spring:bean/>)* | A helper method to allow the destination map to be populated from a dependency injection framework such as Spring
filteredPersistenceAdapters | (<spring:bean/>)* | Sets the FilteredKahaDBPersistenceAdapter entries
transactionStore | <spring:bean/> |
usageManager | systemUsage |

## Element: managementContext

Attribute | Type | Description
--- | --- | ---
allowRemoteAddressInMBeanNames | xs:boolean |
brokerName | xs:string | Gets the broker name this context is used by, may be `null` if the broker name was not set.
connectorHost | xs:string | Get the connectorHost
connectorPath | xs:string |
connectorPort | xs:string |
createConnector | xs:string |
createMBeanServer | xs:boolean |
findTigerMbeanServer | xs:boolean | Enables/disables the searching for the Java 5 platform MBeanServer
jmxDomainName | xs:string |
rmiServerPort | xs:string |
useMBeanServer | xs:boolean |

Element | Type | Description
--- | --- | ---
MBeanServer | <spring:bean/> | Get the MBeanServer
environment | <spring:bean/> |
server | <spring:bean/> |

## Element: masterConnector

Attribute | Type | Description
--- | --- | ---
failedToStart | xs:boolean | Get the failedToStart
localURI | xs:string |
password | xs:string |
remoteURI | xs:string |
remoteUri | xs:string |
userName | xs:string |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |

## Element: maxdb-jdbc-adapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: memoryPersistenceAdapter

Attribute | Type | Description
--- | --- | ---
brokerName | xs:string |
createTransactionStore | xs:boolean |
directory | xs:string |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
usageManager | systemUsage |

## Element: memoryUsage

Attribute | Type | Description
--- | --- | ---
limit | xs:string | Sets the memory limit in bytes. Setting the limit in bytes will set the usagePortion to 0 since the UsageManager is not going to be portion based off the parent. When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
name | xs:string |
percentUsage | xs:integer |
percentUsageMinDelta | xs:string | Sets the minimum number of percentage points the usage has to change before a UsageListener event is fired by the manager.
pollingTime | xs:integer |
portion | xs:float |
usage | xs:long |
usagePortion | xs:float |

Element | Type | Description
--- | --- | ---
executor | <spring:bean/> |
limiter | defaultUsageCapacity | usageCapacity |
parent | <spring:bean/> |

## Element: messageGroupHashBucketFactory

Attribute | Type | Description
--- | --- | ---
bucketCount | xs:integer | Sets the number of hash buckets to use for the message group functionality. This is only applicable to using message groups to parallelize processing of a queue while preserving order across an individual JMSXGroupID header value. This value sets the number of hash buckets that will be used (i.e. the maximum possible concurrency).

## Element: mirroredQueue

Attribute | Type | Description
--- | --- | ---
copyMessage | xs:boolean | Sets whether a copy of the message will be sent to each destination. Defaults to true so that the forward destination is set as the destination of the message
postfix | xs:string | Sets any postix used to identify the queue consumers
prefix | xs:string | Sets the prefix wildcard used to identify the queue consumers for a given topic

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |

## Element: multicastNetworkConnector

Attribute | Type | Description
--- | --- | ---
alwaysSyncSend | xs:boolean |
bridgeTempDestinations | xs:boolean |
brokerName | xs:string |
brokerURL | xs:string |
conduitSubscriptions | xs:boolean |
consumerPriorityBase | xs:integer |
decreaseNetworkConsumerPriority | xs:boolean |
destinationFilter | xs:string |
dispatchAsync | xs:boolean |
duplex | xs:boolean |
dynamicOnly | xs:boolean |
localUri | xs:string |
name | xs:string |
networkTTL | xs:integer |
objectName | xs:string |
password | xs:string |
prefetchSize | xs:string |
remoteURI | xs:string | Sets the remote transport URI to some group transport like `multicast://address:port`
staticBridge | xs:boolean |
suppressDuplicateQueueSubscriptions | xs:boolean |
suppressDuplicateTopicSubscriptions | xs:boolean |
useCompression | xs:boolean |
userName | xs:string |

Element | Type | Description
--- | --- | ---
bridge | compositeDemandForwardingBridge | demandForwardingBridge |
brokerService | broker | brokerService |
connectionFilter | <spring:bean/> |
durableDestinations | (<spring:bean/>)* |
dynamicallyIncludedDestinations | (<spring:bean/>)* |
excludedDestinations | (<spring:bean/>)* |
localTransport | <spring:bean/> |
remoteTransport | <spring:bean/> | Sets the remote transport implementation
staticallyIncludedDestinations | (<spring:bean/>)* |

## Element: multicastTraceBrokerPlugin

Attribute | Type | Description
--- | --- | ---
broadcast | xs:boolean |
destination | xs:string |
maxTraceDatagramSize | xs:integer |
timeToLive | xs:integer |

Element | Type | Description
--- | --- | ---
address | <spring:bean/> |
adminConnectionContext | <spring:bean/> |
next | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |
wireFormat | <spring:bean/> |
wireFormatFactory | <spring:bean/> |

## Element: mysql-jdbc-adapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
engineType | xs:string |
maxRows | xs:integer |
typeStatement | xs:string |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: networkConnector

Attribute | Type | Description
--- | --- | ---
alwaysSyncSend | xs:boolean |
bridgeTempDestinations | xs:boolean |
brokerName | xs:string |
brokerURL | xs:string |
conduitSubscriptions | xs:boolean |
consumerPriorityBase | xs:integer |
decreaseNetworkConsumerPriority | xs:boolean |
destinationFilter | xs:string |
discoveryURI | xs:string |
dispatchAsync | xs:boolean |
duplex | xs:boolean |
dynamicOnly | xs:boolean |
localUri | xs:string |
name | xs:string |
networkTTL | xs:integer |
objectName | xs:string |
password | xs:string |
prefetchSize | xs:string |
staticBridge | xs:boolean |
suppressDuplicateQueueSubscriptions | xs:boolean |
suppressDuplicateTopicSubscriptions | xs:boolean |
uri | xs:string |
useCompression | xs:boolean |
userName | xs:string |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |
connectionFilter | <spring:bean/> |
discoveryAgent | <spring:bean/> |
durableDestinations | (<spring:bean/>)* |
dynamicallyIncludedDestinations | (<spring:bean/>)* |
excludedDestinations | (<spring:bean/>)* |
staticallyIncludedDestinations | (<spring:bean/>)* |

## Element: noSubscriptionRecoveryPolicy

Element | Type | Description
--- | --- | ---
broker | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: oldestMessageEvictionStrategy

Attribute | Type | Description
--- | --- | ---
evictExpiredMessagesHighWatermark | xs:integer | Sets the high water mark on which we will eagerly evict expired messages from RAM

## Element: oldestMessageWithLowestPriorityEvictionStrategy

Attribute | Type | Description
--- | --- | ---
evictExpiredMessagesHighWatermark | xs:integer | Sets the high water mark on which we will eagerly evict expired messages from RAM

## Element: oracleBlobJDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: oracleJDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: outboundQueueBridge

Attribute | Type | Description
--- | --- | ---
doHandleReplyTo | xs:boolean |
localQueueName | xs:string |
outboundQueueName | xs:string | Sets the name of the outbound queue name. If the inbound queue name has not been set already then this method uses the provided queue name to set the inbound topic name as well.
selector | xs:string |

Element | Type | Description
--- | --- | ---
consumer | <spring:bean/> |
consumerConnection | <spring:bean/> |
consumerQueue | queue |
jmsConnector | jmsQueueConnector | jmsTopicConnector |
jmsMessageConvertor | simpleJmsMessageConvertor |
producerConnection | <spring:bean/> |
producerQueue | queue |

## Element: outboundTopicBridge

Attribute | Type | Description
--- | --- | ---
consumerName | xs:string |
doHandleReplyTo | xs:boolean |
localTopicName | xs:string |
outboundTopicName | xs:string | Sets the name of the outbound topic name. If the inbound topic name has not been set already then this method uses the provided topic name to set the inbound topic name as well.
selector | xs:string |

Element | Type | Description
--- | --- | ---
consumer | <spring:bean/> |
consumerConnection | <spring:bean/> |
consumerTopic | topic |
jmsConnector | jmsQueueConnector | jmsTopicConnector |
jmsMessageConvertor | simpleJmsMessageConvertor |
producerConnection | <spring:bean/> |
producerTopic | topic |

## Element: pListStore

Attribute | Type | Description
--- | --- | ---
cleanupInterval | xs:long |
directory | xs:string |
enableIndexWriteAsync | xs:boolean |
failIfDatabaseIsLocked | xs:boolean |
indexCacheSize | xs:integer |
indexEnablePageCaching | xs:boolean |
indexPageSize | xs:integer |
indexWriteBatchSize | xs:integer |
journalMaxFileLength | xs:integer |
journalMaxWriteBatchSize | xs:integer |
lazyInit | xs:boolean |

Element | Type | Description
--- | --- | ---
brokerService | broker | brokerService |

## Element: policyEntry

Attribute | Type | Description
--- | --- | ---
advisoryForConsumed | xs:boolean |
advisoryForDelivery | xs:boolean |
advisoryForDiscardingMessages | xs:boolean |
advisoryForFastProducers | xs:boolean |
advisoryForSlowConsumers | xs:boolean |
advisoryWhenFull | xs:boolean |
allConsumersExclusiveByDefault | xs:boolean |
alwaysRetroactive | xs:boolean |
blockedProducerWarningInterval | xs:long | Set's the interval at which warnings about producers being blocked by resource usage will be triggered. Values of 0 or less will disable warnings
consumersBeforeDispatchStarts | xs:integer |
cursorMemoryHighWaterMark | xs:integer |
doOptimzeMessageStorage | xs:boolean |
durableTopicPrefetch | xs:integer | Get the durableTopicPrefetch
enableAudit | xs:boolean |
expireMessagesPeriod | xs:long |
gcInactiveDestinations | xs:boolean |
gcWithNetworkConsumers | xs:boolean |
inactiveTimoutBeforeGC | xs:long |
lazyDispatch | xs:boolean |
maxAuditDepth | xs:integer |
maxBrowsePageSize | xs:integer |
maxExpirePageSize | xs:integer |
maxPageSize | xs:integer |
maxProducersToAudit | xs:integer |
maxQueueAuditDepth | xs:integer |
memoryLimit | xs:string | When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
minimumMessageSize | xs:long |
optimizeMessageStoreInFlightLimit | xs:integer |
optimizedDispatch | xs:boolean |
prioritizedMessages | xs:boolean |
producerFlowControl | xs:boolean |
queue | xs:string | A helper method to set the destination from a configuration file
queueBrowserPrefetch | xs:integer | Get the queueBrowserPrefetch
queuePrefetch | xs:integer | Get the queuePrefetch
reduceMemoryFootprint | xs:boolean |
sendAdvisoryIfNoConsumers | xs:boolean | Sends an advisory message if a non-persistent message is sent and there are no active consumers
storeUsageHighWaterMark | xs:integer |
strictOrderDispatch | xs:boolean |
tempQueue | xs:boolean |
tempTopic | xs:boolean |
timeBeforeDispatchStarts | xs:integer |
topic | xs:string | A helper method to set the destination from a configuration file
topicPrefetch | xs:integer | Get the topicPrefetch
useCache | xs:boolean |
useConsumerPriority | xs:boolean |
usePrefetchExtension | xs:boolean |

Element | Type | Description
--- | --- | ---
deadLetterStrategy | individualDeadLetterStrategy | sharedDeadLetterStrategy | Sets the policy used to determine which dead letter queue destination should be used
destination | queue | tempQueue | tempTopic | topic |
dispatchPolicy | priorityNetworkDispatchPolicy | roundRobinDispatchPolicy | simpleDispatchPolicy | strictOrderDispatchPolicy |
messageEvictionStrategy | oldestMessageEvictionStrategy | oldestMessageWithLowestPriorityEvictionStrategy | uniquePropertyMessageEvictionStrategy | Sets the eviction strategy used to decide which message to evict when the slow consumer needs to discard messages
messageGroupMapFactory | messageGroupHashBucketFactory | simpleMessageGroupMapFactory | Sets the factory used to create new instances of {MessageGroupMap} used to implement the Message Groups functionality.
networkBridgeFilterFactory | conditionalNetworkBridgeFilterFactory | defaultNetworkBridgeFilterFactory |
pendingDurableSubscriberPolicy | fileDurableSubscriberCursor | storeDurableSubscriberCursor | vmDurableCursor |

pendingMessageLimitStrategy

constantPendingMessageLimitStrategy | prefetchRatePendingMessageLimitStrategy

Sets the strategy to calculate the maximum number of messages that are allowed to be pending on consumers (in addition to their prefetch sizes). Once the limit is reached, non-durable topics can then start discarding old messages. This allows us to keep dispatching messages to slow consumers while not blocking fast consumers and discarding the messages oldest first.

pendingQueuePolicy | fileQueueCursor | storeCursor | vmQueueCursor |
pendingSubscriberPolicy | fileCursor | vmCursor |
slowConsumerStrategy | abortSlowConsumerStrategy |
subscriptionRecoveryPolicy | fixedCountSubscriptionRecoveryPolicy | fixedSizedSubscriptionRecoveryPolicy | lastImageSubscriptionRecoveryPolicy | noSubscriptionRecoveryPolicy | queryBasedSubscriptionRecoveryPolicy | timedSubscriptionRecoveryPolicy |

## Element: policyMap

Element | Type | Description
--- | --- | ---
defaultEntry | policyEntry |
entries | (<spring:bean/>)* | A helper method to allow the destination map to be populated from a dependency injection framework such as Spring
policyEntries | (<spring:bean/>)* | Sets the individual entries on the policy map

## Element: postgresql-jdbc-adapter

Attribute | Type | Description
--- | --- | ---
acksPkName | xs:string |
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: prefetchPolicy

Attribute | Type | Description
--- | --- | ---
all | xs:integer |
durableTopicPrefetch | xs:integer |
inputStreamPrefetch | xs:integer |
maximumPendingMessageLimit | xs:integer | Sets how many messages a broker will keep around, above the prefetch limit, for non-durable topics before starting to discard older messages.
optimizeDurableTopicPrefetch | xs:integer |
queueBrowserPrefetch | xs:integer |
queuePrefetch | xs:integer |
topicPrefetch | xs:integer |

## Element: prefetchRatePendingMessageLimitStrategy

Attribute | Type | Description
--- | --- | ---
multiplier | xs:double | Sets the multiplier of the prefetch size which will be used to define the maximum number of pending messages for non-durable topics before messages are discarded.

## Element: priorityNetworkDispatchPolicy

## Element: proxyConnector

Attribute | Type | Description
--- | --- | ---
bind | xs:string |
localUri | xs:string |
name | xs:string |
proxyToLocalBroker | xs:boolean |
remote | xs:string |

Element | Type | Description
--- | --- | ---
server | <spring:bean/> |

## Element: queryBasedSubscriptionRecoveryPolicy

Element | Type | Description
--- | --- | ---
broker | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |
query | <spring:bean/> | Sets the query strategy to load initial messages

## Element: queue

Attribute | Type | Description
--- | --- | ---
name | xs:string |
physicalName | xs:string |

Element | Type | Description
--- | --- | ---
compositeDestinations | (queue | tempQueue | tempTopic | topic)* |
properties | <spring:bean/> | Get the properties from this instance for storing in JNDI

## Element: queueDispatchSelector

Element | Type | Description
--- | --- | ---
destination | queue | tempQueue | tempTopic | topic |
exclusiveConsumer | <spring:bean/> |

## Element: reconnectionPolicy

Attribute | Type | Description
--- | --- | ---
backOffMultiplier | xs:double | Gets the multiplier used to grow the delay between connection attempts from the initial time to the max set time. By default this value is set to 2.0.
initialReconnectDelay | xs:long | Gets the initial delay value used before a reconnection attempt is made. If the use exponential back-off value is set to false then this will be the fixed time between connection attempts. By default this value is set to one second.
maxInitialConnectAttempts | xs:integer | Gets the maximum number of times that the {@link JmsConnector} will try to connect on startup to before it marks itself as failed and does not try any further connections.
maxReconnectAttempts | xs:integer | Gets the number of time that {@link JmsConnector} will attempt to connect or reconnect before giving up. By default the policy sets this value to a negative value meaning try forever.
maxSendRetries | xs:integer | Gets the maximum number of a times a Message send should be retried before a JMSExeception is thrown indicating that the operation failed.
maximumReconnectDelay | xs:long | Gets the maximum delay that is inserted between each attempt to connect before another attempt is made. The default setting for this value is 30 seconds.
sendRetyDelay | xs:long | Set the amount of time the DestionationBridge will wait between attempts to forward a message. The default policy limits the minimum time between send attempt to one second.
useExponentialBackOff | xs:boolean | Gets whether the policy uses the set back-off multiplier to grow the time between connection attempts.

## Element: redeliveryPlugin

Attribute | Type | Description
--- | --- | ---
fallbackToDeadLetter | xs:boolean | What to do if there is no matching redelivery policy for a destination. when true, the region broker DLQ processing will be used via sendToDeadLetterQueue when false, there is no action
sendToDlqIfMaxRetriesExceeded | xs:boolean | What to do if the maxretries on a matching redelivery policy is exceeded. when true, the region broker DLQ processing will be used via sendToDeadLetterQueue when false, there is no action

Element | Type | Description
--- | --- | ---
adminConnectionContext | <spring:bean/> |
next | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |
redeliveryPolicyMap | redeliveryPolicyMap |

## Element: redeliveryPolicy

Attribute | Type | Description
--- | --- | ---
backOffMultiplier | xs:double |
collisionAvoidancePercent | xs:short |
initialRedeliveryDelay | xs:long |
maximumRedeliveries | xs:integer |
maximumRedeliveryDelay | xs:long |
queue | xs:string | A helper method to set the destination from a configuration file
redeliveryDelay | xs:long |
tempQueue | xs:boolean |
tempTopic | xs:boolean |
topic | xs:string | A helper method to set the destination from a configuration file
useCollisionAvoidance | xs:boolean |
useExponentialBackOff | xs:boolean |

Element | Type | Description
--- | --- | ---
destination | queue | tempQueue | tempTopic | topic |

## Element: redeliveryPolicyMap

Element | Type | Description
--- | --- | ---
defaultEntry | redeliveryPolicy |
entries | (<spring:bean/>)* | A helper method to allow the destination map to be populated from a dependency injection framework such as Spring
redeliveryPolicyEntries | (<spring:bean/>)* | Sets the individual entries on the redeliveryPolicyMap

## Element: roundRobinDispatchPolicy

## Element: shared-file-locker

Attribute | Type | Description
--- | --- | ---
directory | xs:string |
failIfLocked | xs:boolean |
lockAcquireSleepInterval | xs:long |
name | xs:string |

## Element: sharedDeadLetterStrategy

Attribute | Type | Description
--- | --- | ---
enableAudit | xs:boolean |
processExpired | xs:boolean |
processNonPersistent | xs:boolean |

Element | Type | Description
--- | --- | ---
deadLetterQueue | queue | tempQueue | tempTopic | topic |

## Element: simpleAuthenticationPlugin

Attribute | Type | Description
--- | --- | ---
anonymousAccessAllowed | xs:boolean |
anonymousGroup | xs:string |
anonymousUser | xs:string |

Element | Type | Description
--- | --- | ---
userGroups | <spring:bean/> | Sets the groups a user is in. The key is the user name and the value is a Set of groups
userPasswords | <spring:bean/> | Sets the map indexed by user name with the value the password
users | (<spring:bean/>)* | Sets individual users for authentication

## Element: simpleAuthorizationMap

Element | Type | Description
--- | --- | ---
adminACLs | authorizationMap | cachedLDAPAuthorizationMap | mKahaDB | policyMap | redeliveryPolicyMap |
readACLs | authorizationMap | cachedLDAPAuthorizationMap | mKahaDB | policyMap | redeliveryPolicyMap |
tempDestinationAuthorizationEntry | tempDestinationAuthorizationEntry |
writeACLs | authorizationMap | cachedLDAPAuthorizationMap | mKahaDB | policyMap | redeliveryPolicyMap |

## Element: simpleDispatchPolicy

## Element: simpleDispatchSelector

Element | Type | Description
--- | --- | ---
destination | queue | tempQueue | tempTopic | topic |

## Element: simpleJmsMessageConvertor

Element | Type | Description
--- | --- | ---
connection | <spring:bean/> |

## Element: simpleMessageGroupMapFactory

## Element: sslContext

Attribute | Type | Description
--- | --- | ---
keyStore | xs:string |
keyStoreAlgorithm | xs:string |
keyStoreKeyPassword | xs:string |
keyStorePassword | xs:string |
keyStoreType | xs:string |
protocol | xs:string |
provider | xs:string |
secureRandomAlgorithm | xs:string |
trustStore | xs:string |
trustStoreAlgorithm | xs:string |
trustStorePassword | xs:string |
trustStoreType | xs:string |

Element | Type | Description
--- | --- | ---
SSLContext | <spring:bean/> |
keyManagers | (<spring:bean/>)* |
secureRandom | <spring:bean/> |
trustManagers | (<spring:bean/>)* |

## Element: statements

Attribute | Type | Description
--- | --- | ---
addMessageStatement | xs:string |
binaryDataType | xs:string |
clearDurableLastAckInTxStatement | xs:string |
clearXidFlagStatement | xs:string |
containerNameDataType | xs:string |
createDurableSubStatement | xs:string |
currentDateTimeStatement | xs:string |
deleteOldMessagesStatementWithPriority | xs:string |
deleteSubscriptionStatement | xs:string |
destinationMessageCountStatement | xs:string |
dropAckPKAlterStatementEnd | xs:string |
durableSubAcksTableName | xs:string |
durableSubscriberMessageCountStatement | xs:string |
durableSubscriberMessageCountStatementWithPriority | xs:string |
findAcksPendingOutcomeStatement | xs:string |
findAllDestinationsStatement | xs:string |
findAllDurableSubMessagesStatement | xs:string |
findAllDurableSubsStatement | xs:string |
findAllMessagesStatement | xs:string |
findDurableSubMessagesStatement | xs:string |
findDurableSubStatement | xs:string |
findLastSequenceIdInAcksStatement | xs:string |
findLastSequenceIdInMsgsStatement | xs:string |
findMessageByIdStatement | xs:string |
findMessageSequenceIdStatement | xs:string |
findMessageStatement | xs:string |
findNextMessagesStatement | xs:string |
findOpsPendingOutcomeStatement | xs:string |
findXidByIdStatement | xs:string |
insertDurablePriorityAckStatement | xs:string |
lastAckedDurableSubscriberMessageStatement | xs:string |
lastProducerSequenceIdStatement | xs:string |
leaseObtainStatement | xs:string |
leaseOwnerStatement | xs:string |
leaseUpdateStatement | xs:string |
lockCreateStatement | xs:string |
lockTableName | xs:string |
lockUpdateStatement | xs:string |
longDataType | xs:string |
messageTableName | xs:string |
msgIdDataType | xs:string |
nextDurableSubscriberMessageStatement | xs:string |
removeAllMessagesStatement | xs:string |
removeAllSubscriptionsStatement | xs:string |
removeMessageStatment | xs:string |
selectDurablePriorityAckStatement | xs:string |
sequenceDataType | xs:string |
stringIdDataType | xs:string |
tablePrefix | xs:string |
updateDurableLastAckInTxStatement | xs:string |
updateDurableLastAckStatement | xs:string |
updateDurableLastAckWithPriorityInTxStatement | xs:string |
updateDurableLastAckWithPriorityStatement | xs:string |
updateLastPriorityAckRowOfDurableSubStatement | xs:string |
updateMessageStatement | xs:string |
updateXidFlagStatement | xs:string |
useExternalMessageReferences | xs:boolean |
useLockCreateWhereClause | xs:boolean |

Element | Type | Description
--- | --- | ---
createSchemaStatements | (<spring:bean/>)* |
dropSchemaStatements | (<spring:bean/>)* |

## Element: statisticsBrokerPlugin

## Element: storeCursor

## Element: storeDurableSubscriberCursor

Attribute | Type | Description
--- | --- | ---
immediatePriorityDispatch | xs:boolean | Ensure that new higher priority messages will get an immediate dispatch rather than wait for the end of the current cursor batch. Useful when there is a large message backlog and intermittent high priority messages.
useCache | xs:boolean |

## Element: storeUsage

Attribute | Type | Description
--- | --- | ---
limit | xs:string | Sets the memory limit in bytes. Setting the limit in bytes will set the usagePortion to 0 since the UsageManager is not going to be portion based off the parent. When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
name | xs:string |
percentUsage | xs:integer |
percentUsageMinDelta | xs:string | Sets the minimum number of percentage points the usage has to change before a UsageListener event is fired by the manager.
pollingTime | xs:integer |
usagePortion | xs:float |

Element | Type | Description
--- | --- | ---
executor | <spring:bean/> |
limiter | defaultUsageCapacity | usageCapacity |
parent | <spring:bean/> |
store | amqPersistenceAdapter | jdbcPersistenceAdapter | journalPersistenceAdapter | kahaDB | kahaPersistenceAdapter | levelDB | mKahaDB | memoryPersistenceAdapter |

## Element: streamJDBCAdapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: strictOrderDispatchPolicy

## Element: sybase-jdbc-adapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: systemUsage

Attribute | Type | Description
--- | --- | ---
name | xs:string |
sendFailIfNoSpace | xs:boolean | Sets whether or not a send() should fail if there is no space free. The default value is false which means to block the send() method until space becomes available
sendFailIfNoSpaceAfterTimeout | xs:long |
sendFailIfNoSpaceExplicitySet | xs:boolean |

Element | Type | Description
--- | --- | ---
adapter | amqPersistenceAdapter | jdbcPersistenceAdapter | journalPersistenceAdapter | kahaDB | kahaPersistenceAdapter | levelDB | mKahaDB | memoryPersistenceAdapter |
executor | <spring:bean/> |
memoryUsage | memoryUsage |
parent | systemUsage |
storeUsage | storeUsage |
tempStore | pListStore |
tempUsage | tempUsage |

## Element: taskRunnerFactory

Attribute | Type | Description
--- | --- | ---
daemon | xs:boolean |
dedicatedTaskRunner | xs:boolean |
maxIterationsPerRun | xs:integer |
maxThreadPoolSize | xs:integer |
name | xs:string |
priority | xs:integer |
shutdownAwaitTermination | xs:long |

Element | Type | Description
--- | --- | ---
executor | <spring:bean/> |
rejectedTaskHandler | <spring:bean/> |

## Element: tempDestinationAuthorizationEntry

Attribute | Type | Description
--- | --- | ---
admin | xs:string |
groupClass | xs:string |
queue | xs:string | A helper method to set the destination from a configuration file
read | xs:string |
tempQueue | xs:boolean |
tempTopic | xs:boolean |
topic | xs:string | A helper method to set the destination from a configuration file
write | xs:string |

Element | Type | Description
--- | --- | ---
adminACLs | (<spring:bean/>)* |
destination | queue | tempQueue | tempTopic | topic |
readACLs | (<spring:bean/>)* |
writeACLs | (<spring:bean/>)* |

## Element: tempQueue

Attribute | Type | Description
--- | --- | ---
connectionId | xs:string |
name | xs:string |
physicalName | xs:string |
sequenceId | xs:long |

Element | Type | Description
--- | --- | ---
compositeDestinations | (queue | tempQueue | tempTopic | topic)* |
connection | <spring:bean/> |
properties | <spring:bean/> | Get the properties from this instance for storing in JNDI

## Element: tempTopic

Attribute | Type | Description
--- | --- | ---
connectionId | xs:string |
name | xs:string |
physicalName | xs:string |
sequenceId | xs:long |

Element | Type | Description
--- | --- | ---
compositeDestinations | (queue | tempQueue | tempTopic | topic)* |
connection | <spring:bean/> |
properties | <spring:bean/> | Get the properties from this instance for storing in JNDI

## Element: tempUsage

Attribute | Type | Description
--- | --- | ---
limit | xs:string | Sets the memory limit in bytes. Setting the limit in bytes will set the usagePortion to 0 since the UsageManager is not going to be portion based off the parent. When set using Xbean, values of the form "20 Mb", "1024kb", and "1g" can be used
name | xs:string |
percentUsage | xs:integer |
percentUsageMinDelta | xs:string | Sets the minimum number of percentage points the usage has to change before a UsageListener event is fired by the manager.
pollingTime | xs:integer |
usagePortion | xs:float |

Element | Type | Description
--- | --- | ---
executor | <spring:bean/> |
limiter | defaultUsageCapacity | usageCapacity |
parent | <spring:bean/> |
store | pListStore |

## Element: timeStampingBrokerPlugin

Attribute | Type | Description
--- | --- | ---
futureOnly | xs:boolean |
ttlCeiling | xs:long | setter method for ttlCeiling
zeroExpirationOverride | xs:long | setter method for zeroExpirationOverride

Element | Type | Description
--- | --- | ---
adminConnectionContext | <spring:bean/> |
next | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |
processNetworkMessages | <spring:bean/> |

## Element: timedSubscriptionRecoveryPolicy

Attribute | Type | Description
--- | --- | ---
recoverDuration | xs:long |

Element | Type | Description
--- | --- | ---
broker | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: topic

Attribute | Type | Description
--- | --- | ---
name | xs:string |
physicalName | xs:string |

Element | Type | Description
--- | --- | ---
compositeDestinations | (queue | tempQueue | tempTopic | topic)* |
properties | <spring:bean/> | Get the properties from this instance for storing in JNDI

## Element: traceBrokerPathPlugin

Attribute | Type | Description
--- | --- | ---
stampProperty | xs:string |

Element | Type | Description
--- | --- | ---
adminConnectionContext | <spring:bean/> |
next | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |

## Element: transact-database-locker

Attribute | Type | Description
--- | --- | ---
failIfLocked | xs:boolean |
lockAcquireSleepInterval | xs:long |
name | xs:string |
queryTimeout | xs:integer |

Element | Type | Description
--- | --- | ---
exceptionHandler | <spring:bean/> |

## Element: transact-jdbc-adapter

Attribute | Type | Description
--- | --- | ---
batchStatments | xs:boolean |
maxRows | xs:integer |
useExternalMessageReferences | xs:boolean |

Element | Type | Description
--- | --- | ---
statements | statements |

## Element: transportConnector

Attribute | Type | Description
--- | --- | ---
auditNetworkProducers | xs:boolean | Enable a producer audit on network connections, Traps the case of a missing send reply and resend. Note: does not work with conduit=false, networked composite destinations or networked virtual topics
disableAsyncDispatch | xs:boolean |
discoveryUri | xs:string |
enableStatusMonitor | xs:boolean |
maximumConsumersAllowedPerConnection | xs:integer |
maximumProducersAllowedPerConnection | xs:integer |
name | xs:string |
rebalanceClusterClients | xs:boolean |
updateClusterClients | xs:boolean |
updateClusterClientsOnRemove | xs:boolean |
updateClusterFilter | xs:string |
uri | xs:string | Sets the server transport URI to use if there is not a {@link TransportServer} configured via the {@link #setServer(TransportServer)} method. This value is used to lazy create a {@link TransportServer} instance

Element | Type | Description
--- | --- | ---
brokerInfo | <spring:bean/> |
brokerService | broker | brokerService | This is called by the BrokerService right before it starts the transport.
discoveryAgent | <spring:bean/> |
messageAuthorizationPolicy | <spring:bean/> | Sets the policy used to decide if the current connection is authorized to consume a given message
server | <spring:bean/> |
taskRunnerFactory | taskRunnerFactory |

## Element: udpTraceBrokerPlugin

Attribute | Type | Description
--- | --- | ---
broadcast | xs:boolean |
destination | xs:string |
maxTraceDatagramSize | xs:integer |

Element | Type | Description
--- | --- | ---
address | <spring:bean/> |
adminConnectionContext | <spring:bean/> |
next | destinationPathSeparatorPlugin | forcePersistencyModeBroker | loggingBrokerPlugin | multicastTraceBrokerPlugin | redeliveryPlugin | timeStampingBrokerPlugin | traceBrokerPathPlugin | udpTraceBrokerPlugin |
wireFormat | <spring:bean/> |
wireFormatFactory | <spring:bean/> |

## Element: uniquePropertyMessageEvictionStrategy

Attribute | Type | Description
--- | --- | ---
evictExpiredMessagesHighWatermark | xs:integer | Sets the high water mark on which we will eagerly evict expired messages from RAM
propertyName | xs:string |

## Element: usageCapacity

Attribute | Type | Description
--- | --- | ---
limit | xs:long |

## Element: virtualDestinationInterceptor

Element | Type | Description
--- | --- | ---
virtualDestinations | (compositeQueue | compositeTopic | virtualTopic)* |

## Element: virtualSelectorCacheBrokerPlugin

Attribute | Type | Description
--- | --- | ---
persistFile | xs:string | Sets the location of the persistent cache

## Element: virtualTopic

Attribute | Type | Description
--- | --- | ---
local | xs:boolean |
name | xs:string |
postfix | xs:string | Sets any postix used to identify the queue consumers
prefix | xs:string | Sets the prefix wildcard used to identify the queue consumers for a given topic
selectorAware | xs:boolean | Indicates whether the selectors of consumers are used to determine dispatch to a virtual destination, when true only messages matching an existing consumer will be dispatched.

## Element: vmCursor

## Element: vmDurableCursor

## Element: vmQueueCursor

## Element: xaConnectionFactory

Attribute | Type | Description
--- | --- | ---
alwaysSessionAsync | xs:boolean | If this flag is not set then a separate thread is not used for dispatching messages for each Session in the Connection. However, a separate thread is always used if there is more than one session, or the session isn't in auto acknowledge or duplicates ok mode. By default this value is set to true and session dispatch happens asynchronously.
alwaysSyncSend | xs:boolean | Set true if always require messages to be sync sent
auditDepth | xs:integer |
auditMaximumProducerNumber | xs:integer |
beanName | xs:string |
brokerURL | xs:string | Sets the connection URL used to connect to the ActiveMQ broker.
checkForDuplicates | xs:boolean |
clientID | xs:string | Sets the JMS clientID to use for the created connection. Note that this can only be used by one connection at once so generally its a better idea to set the clientID on a Connection
clientIDPrefix | xs:string | Sets the prefix used by autogenerated JMS Client ID values which are used if the JMS client does not explicitly specify on.
closeTimeout | xs:integer | Sets the timeout before a close is considered complete. Normally a close() on a connection waits for confirmation from the broker; this allows that operation to timeout to save the client hanging if there is no broker
connectionIDPrefix | xs:string | Sets the prefix used by connection id generator
consumerFailoverRedeliveryWaitPeriod | xs:long |
copyMessageOnSend | xs:boolean | Should a JMS message be copied to a new JMS Message object as part of the send() method in JMS. This is enabled by default to be compliant with the JMS specification. You can disable it if you do not mutate JMS messages after they are sent for a performance boost
disableTimeStampsByDefault | xs:boolean | Sets whether or not timestamps on messages should be disabled or not. If you disable them it adds a small performance boost.

dispatchAsync

xs:boolean

Enables or disables the default setting of whether or not consumers have their messages dispatched synchronously or asynchronously by the broker. For non-durable topics for example we typically dispatch synchronously by default to minimize context switches which boost performance. However sometimes its better to go slower to ensure that a single blocked consumer socket does not block delivery to other consumers.

exclusiveConsumer | xs:boolean | Enables or disables whether or not queue consumers should be exclusive or not for example to preserve ordering when not using Message Groups
maxThreadPoolSize | xs:integer |
messagePrioritySupported | xs:boolean |
nestedMapAndListEnabled | xs:boolean | Enables/disables whether or not Message properties and MapMessage entries support Nested Structures of Map and List objects
nonBlockingRedelivery | xs:boolean | When true a MessageConsumer will not stop Message delivery before re-delivering Messages from a rolled back transaction. This implies that message order will not be preserved and also will result in the TransactedIndividualAck option to be enabled.
objectMessageSerializationDefered | xs:boolean | When an object is set on an ObjectMessage, the JMS spec requires the object to be serialized by that set method. Enabling this flag causes the object to not get serialized. The object may subsequently get serialized if the message needs to be sent over a socket or stored to disk.
optimizeAcknowledge | xs:boolean |
optimizeAcknowledgeTimeOut | xs:long | The max time in milliseconds between optimized ack batches
optimizedAckScheduledAckInterval | xs:long | Gets the configured time interval that is used to force all MessageConsumers that have optimizedAcknowledge enabled to send an ack for any outstanding Message Acks. By default this value is set to zero meaning that the consumers will not do any background Message acknowledgment.
optimizedMessageDispatch | xs:boolean | If this flag is set then an larger prefetch limit is used - only applicable for durable topic subscribers.
password | xs:string | Sets the JMS password used for connections created from this factory
producerWindowSize | xs:integer |
sendAcksAsync | xs:boolean |
sendTimeout | xs:integer |
statsEnabled | xs:boolean |
transactedIndividualAck | xs:boolean | when true, submit individual transacted acks immediately rather than with transaction completion. This allows the acks to represent delivery status which can be persisted on rollback Used in conjunction with org.apache.activemq.store.kahadb.KahaDBPersistenceAdapter#setRewriteOnRedelivery(boolean) true
useAsyncSend | xs:boolean | Forces the use of Async Sends which adds a massive performance boost; but means that the send() method will return immediately whether the message has been sent or not which could lead to message loss.
useBeanNameAsClientIdPrefix | xs:boolean |
useCompression | xs:boolean | Enables the use of compression of the message bodies
useDedicatedTaskRunner | xs:boolean |
useRetroactiveConsumer | xs:boolean | Sets whether or not retroactive consumers are enabled. Retroactive consumers allow non-durable topic subscribers to receive old messages that were published before the non-durable subscriber started.
userName | xs:string | Sets the JMS userName used by connections created by this factory

warnAboutUnstartedConnectionTimeout

xs:long

Enables the timeout from a connection creation to when a warning is generated if the connection is not properly started via {@link Connection#start()} and a message is received by a consumer. It is a very common gotcha to forget to start the connection so this option makes the default case to create a warning if the user forgets. To disable the warning just set the value to < 0 (say -1).

watchTopicAdvisories | xs:boolean |

Element | Type | Description
--- | --- | ---
blobTransferPolicy | <spring:bean/> | Sets the policy used to describe how out-of-band BLOBs (Binary Large OBjects) are transferred from producers to brokers to consumers
clientIdGenerator | <spring:bean/> |

clientInternalExceptionListener

<spring:bean/>

Allows an {@link ClientInternalExceptionListener} to be configured on the ConnectionFactory so that when this factory is used by frameworks which don't expose the Connection such as Spring JmsTemplate, you can register an exception listener.

Note: access to this clientInternalExceptionListener will not be serialized if it is associated with more than on connection (as it will be if more than one connection is subsequently created by this connection factory)

connectionIdGenerator | <spring:bean/> |

exceptionListener

commandAgent

Allows an {@link ExceptionListener} to be configured on the ConnectionFactory so that when this factory is used by frameworks which don't expose the Connection such as Spring JmsTemplate, you can register an exception listener.

Note: access to this exceptionLinstener will not be serialized if it is associated with more than on connection (as it will be if more than one connection is subsequently created by this connection factory)

prefetchPolicy | prefetchPolicy | Sets the prefetch policy for consumers created by this connection.
properties | <spring:bean/> | Get the properties from this instance for storing in JNDI
redeliveryPolicy | redeliveryPolicy | Sets the global default redelivery policy to be used when a message is delivered but the session is rolled back
redeliveryPolicyMap | redeliveryPolicyMap | Sets the global redelivery policy mapping to be used when a message is delivered but the session is rolled back
rejectedTaskHandler | <spring:bean/> |
sessionTaskRunner | taskRunnerFactory |
transformer | <spring:bean/> | Sets the transformer used to transform messages before they are sent on to the JMS bus or when they are received from the bus but before they are delivered to the JMS client
transportListener | <spring:bean/> | Allows a listener to be configured on the ConnectionFactory so that when this factory is used with frameworks which don't expose the Connection such as Spring JmsTemplate, you can still register a transport listener.